{
    "scan": {
        "analyzer-version-clang": "18.1.3",
        "analyzer-version-cppcheck": "2.13.0",
        "analyzer-version-gcc": "14.0.1",
        "analyzer-version-gcc-analyzer": "14.0.1",
        "analyzer-version-shellcheck": "0.10.0",
        "enabled-plugins": "clang, cppcheck, gcc, shellcheck",
        "exit-code": 0,
        "host": "ip-172-16-1-254.us-west-2.compute.internal",
        "mock-config": "fedora-41-x86_64",
        "project-name": "coreutils-9.5-1.fc41",
        "store-results-to": "/tmp/tmpzr0hps4v/coreutils-9.5-1.fc41.tar.xz",
        "time-created": "2024-04-22 10:51:23",
        "time-finished": "2024-04-22 10:58:41",
        "tool": "csmock",
        "tool-args": "'/usr/bin/csmock' '-r' 'fedora-41-x86_64' '-t' 'cppcheck,gcc,clang,shellcheck' '-o' '/tmp/tmpzr0hps4v/coreutils-9.5-1.fc41.tar.xz' '--gcc-analyze' '/tmp/tmpzr0hps4v/coreutils-9.5-1.fc41.src.rpm'",
        "tool-version": "csmock-3.5.3-1.el9"
    },
    "defects": [
        {
            "checker": "SHELLCHECK_WARNING",
            "cwe": 758,
            "language": "shell",
            "tool": "shellcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/etc/profile.d/colorls.sh",
                    "line": 1,
                    "column": 1,
                    "event": "error[SC2148]",
                    "message": "Tips depend on target shell and yours is unknown. Add a shebang or a 'shell' directive.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "    1|-> # color-ls initialization",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "    2|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "    3|   # Skip all for noninteractive shells.",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/gnulib-tests/strerror_r.c",
                    "line": 165,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'ret' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/gnulib-tests/strerror_r.c",
                    "line": 165,
                    "column": 7,
                    "event": "note",
                    "message": "Value stored to 'ret' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  163|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  164|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  165|->       ret = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  166|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  167|   # if HAVE___XPG_STRERROR_R",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 2,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 26,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'decode_preserve_arg'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/argmatch.h",
                    "line": 108,
                    "column": 15,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xstrdup(arg)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 922,
                    "column": 13,
                    "event": "note",
                    "message": "in expansion of macro 'XARGMATCH'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 909,
                    "column": 24,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 914,
                    "column": 21,
                    "event": "note",
                    "message": "(2) when 'strchr' returns non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 918,
                    "column": 10,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'comma' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 919,
                    "column": 15,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 924,
                    "column": 7,
                    "event": "note",
                    "message": "(5) following 'case 0:' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 926,
                    "column": 9,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 969,
                    "column": 10,
                    "event": "note",
                    "message": "(7) following 'true' branch (when 'comma' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 914,
                    "column": 21,
                    "event": "note",
                    "message": "(9) when 'strchr' returns NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 918,
                    "column": 10,
                    "event": "note",
                    "message": "(10) following 'false' branch (when 'comma' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/argmatch.h",
                    "line": 108,
                    "column": 15,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 922,
                    "column": 13,
                    "event": "note",
                    "message": "in expansion of macro 'XARGMATCH'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/argmatch.h",
                    "line": 108,
                    "column": 15,
                    "event": "note",
                    "message": "(12) following 'true' branch (when 'on_off != 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 922,
                    "column": 13,
                    "event": "note",
                    "message": "in expansion of macro 'XARGMATCH'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/argmatch.h",
                    "line": 108,
                    "column": 15,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 922,
                    "column": 13,
                    "event": "note",
                    "message": "in expansion of macro 'XARGMATCH'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/argmatch.h",
                    "line": 108,
                    "column": 15,
                    "event": "note",
                    "message": "(14) 'xstrdup(arg)' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 922,
                    "column": 13,
                    "event": "note",
                    "message": "in expansion of macro 'XARGMATCH'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  106|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  107|   # define XARGMATCH(Context, Arg, Arglist, Vallist)              \\",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  108|->   ((Vallist) [__xargmatch_internal (Context, Arg, Arglist,      \\",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  109|                                       (void const *) (Vallist),   \\",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  110|                                       sizeof *(Vallist),          \\",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'canon_host_r'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 75,
                    "column": 27,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'canon_host_r(host, & last_cherror)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 33,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'canon_host'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 35,
                    "column": 10,
                    "event": "note",
                    "message": "(2) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 35,
                    "column": 10,
                    "event": "note",
                    "message": "(3) calling 'canon_host_r' from 'canon_host'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 61,
                    "column": 1,
                    "event": "note",
                    "message": "(4) entry to 'canon_host_r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 70,
                    "column": 6,
                    "event": "note",
                    "message": "(5) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 75,
                    "column": 27,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 76,
                    "column": 10,
                    "event": "note",
                    "message": "(7) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 78,
                    "column": 7,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 75,
                    "column": 27,
                    "event": "note",
                    "message": "(9) 'canon_host_r(host, & last_cherror)' leaks here; was allocated at (2)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   73|            says Darwin 7.9.0 getaddrinfo returns 0 but sets",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   74|            res->ai_canonname to NULL.  */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   75|->       retval = strdup (res->ai_canonname ? res->ai_canonname : host);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   76|         if (!retval && cherror)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   77|           *cherror = EAI_MEMORY;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 83,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'canon_host_r(host, & last_cherror)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 33,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'canon_host'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 35,
                    "column": 10,
                    "event": "note",
                    "message": "(2) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 35,
                    "column": 10,
                    "event": "note",
                    "message": "(3) calling 'canon_host_r' from 'canon_host'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 61,
                    "column": 1,
                    "event": "note",
                    "message": "(4) entry to 'canon_host_r'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 70,
                    "column": 6,
                    "event": "note",
                    "message": "(5) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 80,
                    "column": 11,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 80,
                    "column": 11,
                    "event": "note",
                    "message": "(7) following 'true' branch (when 'cherror' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 81,
                    "column": 14,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/canon-host.c",
                    "line": 83,
                    "column": 10,
                    "event": "note",
                    "message": "(9) 'canon_host_r(host, & last_cherror)' leaks here; was allocated at (2)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   81|       *cherror = status;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   82|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   83|->   return retval;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   84|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   85|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/canonicalize.c",
                    "line": 387,
                    "column": 15,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'name' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/canonicalize.c",
                    "line": 387,
                    "column": 15,
                    "event": "note",
                    "message": "Value stored to 'name' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  385|                 /* Careful here, end may be a pointer into extra_buf... */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  386|                 memmove (&extra_buf[n], end, len + 1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  387|->               name = end = memcpy (extra_buf, buf, n);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  388|                 end_in_extra_buffer = true;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  389|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "cwe": 562,
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/careadlinkat.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'careadlinkat.constprop'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/careadlinkat.c",
                    "line": 180,
                    "column": 10,
                    "event": "warning[-Wreturn-local-addr]",
                    "message": "function may return address of local variable",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  180 |   return readlink_stk (fd, filename, buffer, buffer_size, alloc,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |          ^",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/careadlinkat.c",
                    "line": 179,
                    "column": 8,
                    "event": "note",
                    "message": "declared here",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  179 |   char stack_buf[STACK_BUF_SIZE];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "      |        ^",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  178|     #endif",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  179|     char stack_buf[STACK_BUF_SIZE];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  180|->   return readlink_stk (fd, filename, buffer, buffer_size, alloc,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  181|                          preadlinkat, stack_buf);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  182|   }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'add_exclude'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 579,
                    "column": 20,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xstrdup(pattern)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 578,
                    "column": 19,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 579,
                    "column": 20,
                    "event": "note",
                    "message": "(2) 'xstrdup(pattern)' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  577|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  578|         char *str = xstrdup (pattern);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  579|->       if ((options & (EXCLUDE_WILDCARDS | FNM_NOESCAPE)) == EXCLUDE_WILDCARDS)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  580|           unescape_pattern (str);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  581|         if (hash_insert (ex->head->v.table, str) != str)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'add_exclude_fp'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 604,
                    "column": 24,
                    "event": "warning[-Wanalyzer-null-dereference]",
                    "message": "dereference of NULL 'buf'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 657,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'add_exclude_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 661,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch (when the strings are non-equal)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 30,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 664,
                    "column": 14,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 665,
                    "column": 6,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 667,
                    "column": 12,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 667,
                    "column": 12,
                    "event": "note",
                    "message": "(6) calling 'add_exclude_fp' from 'add_exclude_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 592,
                    "column": 1,
                    "event": "note",
                    "message": "(7) entry to 'add_exclude_fp'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 47,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 106,
                    "column": 19,
                    "event": "note",
                    "message": "(8) inlined call to 'getc_unlocked' from 'add_exclude_fp'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 600,
                    "column": 20,
                    "event": "note",
                    "message": "in expansion of macro 'getc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/bits/stdio.h",
                    "line": 68,
                    "column": 10,
                    "event": "note",
                    "message": "(9) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/bits/stdio.h",
                    "line": 68,
                    "column": 10,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'add_exclude_fp'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 602,
                    "column": 10,
                    "event": "note",
                    "message": "(11) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 604,
                    "column": 20,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 604,
                    "column": 10,
                    "event": "note",
                    "message": "(13) 'buf' is NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/exclude.c",
                    "line": 604,
                    "column": 24,
                    "event": "note",
                    "message": "(14) dereference of NULL 'buf + (sizetype)buf_count'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  602|         if (buf_count == buf_alloc)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  603|           buf = xpalloc (buf, &buf_alloc, 1, -1, 1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  604|->       buf[buf_count++] = c;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  605|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  606|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/file-set.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'record_file'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/file-set.c",
                    "line": 43,
                    "column": 8,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc(24)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/file-set.c",
                    "line": 33,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'false' branch (when 'ht' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/file-set.c",
                    "line": 36,
                    "column": 9,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/file-set.c",
                    "line": 36,
                    "column": 9,
                    "event": "note",
                    "message": "(3) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/file-set.c",
                    "line": 43,
                    "column": 8,
                    "event": "note",
                    "message": "(4) 'xmalloc(24)' leaks here; was allocated at (3)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   41|     {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   42|       struct F_triple *ent_from_table = hash_insert (ht, ent);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   43|->     if (ent_from_table == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   44|         {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   45|           /* Insertion failed due to lack of memory.  */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/file-set.c",
                    "line": 49,
                    "column": 8,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc(24)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/file-set.c",
                    "line": 33,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'false' branch (when 'ht' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/file-set.c",
                    "line": 36,
                    "column": 9,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/file-set.c",
                    "line": 36,
                    "column": 9,
                    "event": "note",
                    "message": "(3) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/file-set.c",
                    "line": 43,
                    "column": 8,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/file-set.c",
                    "line": 49,
                    "column": 8,
                    "event": "note",
                    "message": "(5) ...to here (6) 'xmalloc(24)' leaks here; was allocated at (3)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   47|         }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   48|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   49|->     if (ent_from_table != ent)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   50|         {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   51|           /* There was already a matching entry in the table, so ENT was",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 2,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 225,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/fts-cycle.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'enter_dir'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/fts-cycle.c",
                    "line": 94,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'ad'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1267,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'fts_build'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1287,
                    "column": 12,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 239,
                    "column": 29,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1245,
                    "column": 22,
                    "event": "note",
                    "message": "in expansion of macro 'ISSET'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1307,
                    "column": 34,
                    "event": "note",
                    "message": "in expansion of macro 'fts_opendir'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1307,
                    "column": 16,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1319,
                    "column": 41,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1327,
                    "column": 17,
                    "event": "note",
                    "message": "(6) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 273,
                    "column": 7,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1330,
                    "column": 19,
                    "event": "note",
                    "message": "in expansion of macro 'LEAVE_DIR'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 273,
                    "column": 7,
                    "event": "note",
                    "message": "(8) calling 'leave_dir' from 'fts_build'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1330,
                    "column": 19,
                    "event": "note",
                    "message": "in expansion of macro 'LEAVE_DIR'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/fts-cycle.c",
                    "line": 125,
                    "column": 1,
                    "event": "note",
                    "message": "(9) entry to 'leave_dir'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts-cycle.c",
                    "line": 135,
                    "column": 10,
                    "event": "note",
                    "message": "(10) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts-cycle.c",
                    "line": 137,
                    "column": 7,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 273,
                    "column": 7,
                    "event": "note",
                    "message": "(12) returning to 'fts_build' from 'leave_dir'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1330,
                    "column": 19,
                    "event": "note",
                    "message": "in expansion of macro 'LEAVE_DIR'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1331,
                    "column": 20,
                    "event": "note",
                    "message": "(13) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1343,
                    "column": 20,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1343,
                    "column": 20,
                    "event": "note",
                    "message": "(15) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1345,
                    "column": 28,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1345,
                    "column": 28,
                    "event": "note",
                    "message": "(17) calling 'enter_dir' from 'fts_build'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts-cycle.c",
                    "line": 74,
                    "column": 1,
                    "event": "note",
                    "message": "(18) entry to 'enter_dir'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts-cycle.c",
                    "line": 76,
                    "column": 6,
                    "event": "note",
                    "message": "(19) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts-cycle.c",
                    "line": 79,
                    "column": 31,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts-cycle.c",
                    "line": 79,
                    "column": 31,
                    "event": "note",
                    "message": "(21) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts-cycle.c",
                    "line": 82,
                    "column": 10,
                    "event": "note",
                    "message": "(22) assuming 'ad' is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts-cycle.c",
                    "line": 82,
                    "column": 10,
                    "event": "note",
                    "message": "(23) following 'false' branch (when 'ad' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts-cycle.c",
                    "line": 85,
                    "column": 19,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts-cycle.c",
                    "line": 94,
                    "column": 10,
                    "event": "note",
                    "message": "(25) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(26) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts-cycle.c",
                    "line": 94,
                    "column": 10,
                    "event": "note",
                    "message": "(27) 'ad' leaks here; was allocated at (21)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   92|         ad_from_table = hash_insert (fts->fts_cycle.ht, ad);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   93|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   94|->       if (ad_from_table != ad)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   95|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   96|             free (ad);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'filesystem_type'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 714,
                    "column": 12,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 't2'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1267,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'fts_build'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1307,
                    "column": 16,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1319,
                    "column": 41,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1379,
                    "column": 12,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1390,
                    "column": 24,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1390,
                    "column": 24,
                    "event": "note",
                    "message": "(6) following 'true' branch (when 'type != 2')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1391,
                    "column": 30,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1390,
                    "column": 24,
                    "event": "note",
                    "message": "(8) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1392,
                    "column": 47,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1392,
                    "column": 30,
                    "event": "note",
                    "message": "(10) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1393,
                    "column": 34,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1393,
                    "column": 34,
                    "event": "note",
                    "message": "(12) calling 'leaf_optimization' from 'fts_build'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 785,
                    "column": 1,
                    "event": "note",
                    "message": "(13) entry to 'leaf_optimization'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 787,
                    "column": 11,
                    "event": "note",
                    "message": "(14) calling 'filesystem_type' from 'leaf_optimization'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 704,
                    "column": 1,
                    "event": "note",
                    "message": "(15) entry to 'filesystem_type'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 713,
                    "column": 6,
                    "event": "note",
                    "message": "(16) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 716,
                    "column": 6,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 725,
                    "column": 10,
                    "event": "note",
                    "message": "(18) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 730,
                    "column": 6,
                    "event": "note",
                    "message": "(20) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 733,
                    "column": 6,
                    "event": "note",
                    "message": "(21) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 733,
                    "column": 6,
                    "event": "note",
                    "message": "(22) following 'true' branch (when 'h' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 735,
                    "column": 29,
                    "event": "note",
                    "message": "(23) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 735,
                    "column": 29,
                    "event": "note",
                    "message": "(24) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 736,
                    "column": 10,
                    "event": "note",
                    "message": "(25) assuming 't2' is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 736,
                    "column": 10,
                    "event": "note",
                    "message": "(26) following 'true' branch (when 't2' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 738,
                    "column": 36,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 742,
                    "column": 14,
                    "event": "note",
                    "message": "(28) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 199,
                    "column": 12,
                    "event": "note",
                    "message": "(29) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 743,
                    "column": 13,
                    "event": "note",
                    "message": "in expansion of macro 'fts_assert'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 199,
                    "column": 12,
                    "event": "note",
                    "message": "(30) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 743,
                    "column": 13,
                    "event": "note",
                    "message": "in expansion of macro 'fts_assert'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 749,
                    "column": 16,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 714,
                    "column": 12,
                    "event": "note",
                    "message": "(32) 't2' leaks here; was allocated at (24)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  712|        since the caller is not serious about performance.  */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  713|     if (!ISSET (FTS_CWDFD))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  714|->     return 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  715|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  716|     if (! h)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'fts_build'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1307,
                    "column": 16,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of '**sp.fts_cur.fts_dirp'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1287,
                    "column": 12,
                    "event": "note",
                    "message": "(1) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 239,
                    "column": 29,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1245,
                    "column": 22,
                    "event": "note",
                    "message": "in expansion of macro 'ISSET'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1307,
                    "column": 34,
                    "event": "note",
                    "message": "in expansion of macro 'fts_opendir'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1242,
                    "column": 9,
                    "event": "note",
                    "message": "(3) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1307,
                    "column": 34,
                    "event": "note",
                    "message": "in expansion of macro 'fts_opendir'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/fts.c",
                    "line": 1307,
                    "column": 16,
                    "event": "note",
                    "message": "(4) '**sp.fts_cur.fts_dirp' leaks here; was allocated at (3)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1305|               /* Open the directory for reading.  If this fails, we're done.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1306|                  If being called from fts_read, set the fts_info field. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1307|->             if ((cur->fts_dirp = fts_opendir(cur->fts_accpath, &dir_fd)) == NULL)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1308|                 {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1309|                   if (type == BREAD)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/human.c",
                    "line": 177,
                    "column": 15,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'grouping' during its initialization is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/human.c",
                    "line": 177,
                    "column": 15,
                    "event": "note",
                    "message": "Value stored to 'grouping' during its initialization is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  175|     char const *decimal_point = \".\";",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  176|     size_t decimal_pointlen = 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  177|->   char const *grouping = \"\";",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  178|     char const *thousands_sep = \"\";",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  179|     struct lconv const *l = localeconv ();",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/ialloc.h",
                    "line": 60,
                    "column": 37,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'ximalloc(s + 1)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'ximalloc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 327,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'ximemdup0'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 329,
                    "column": 18,
                    "event": "note",
                    "message": "(2) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 329,
                    "column": 18,
                    "event": "note",
                    "message": "(3) calling 'ximalloc' from 'ximemdup0'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 49,
                    "column": 1,
                    "event": "note",
                    "message": "(4) entry to 'ximalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 51,
                    "column": 10,
                    "event": "note",
                    "message": "(5) inlined call to 'check_nonnull' from 'ximalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 35,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'ximalloc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 51,
                    "column": 10,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 51,
                    "column": 10,
                    "event": "note",
                    "message": "(8) inlined call to 'imalloc' from 'ximalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/ialloc.h",
                    "line": 60,
                    "column": 37,
                    "event": "note",
                    "message": "(9) 'ximalloc(s + 1)' leaks here; was allocated at (2)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   58|   imalloc (idx_t s)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   59|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   60|->   return s <= SIZE_MAX ? malloc (s) : _gl_alloc_nomem ();",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   61|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   62|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/ialloc.h",
                    "line": 60,
                    "column": 37,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'ximalloc(s)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'ximalloc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 318,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'ximemdup'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 320,
                    "column": 10,
                    "event": "note",
                    "message": "(2) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 320,
                    "column": 10,
                    "event": "note",
                    "message": "(3) calling 'ximalloc' from 'ximemdup'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 49,
                    "column": 1,
                    "event": "note",
                    "message": "(4) entry to 'ximalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 51,
                    "column": 10,
                    "event": "note",
                    "message": "(5) inlined call to 'check_nonnull' from 'ximalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 35,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'ximalloc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 51,
                    "column": 10,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 51,
                    "column": 10,
                    "event": "note",
                    "message": "(8) inlined call to 'imalloc' from 'ximalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/ialloc.h",
                    "line": 60,
                    "column": 37,
                    "event": "note",
                    "message": "(9) 'ximalloc(s)' leaks here; was allocated at (2)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   58|   imalloc (idx_t s)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   59|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   60|->   return s <= SIZE_MAX ? malloc (s) : _gl_alloc_nomem ();",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   61|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   62|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/ialloc.h",
                    "line": 106,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xicalloc(s, 1)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'xicalloc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 287,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'xizalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 289,
                    "column": 10,
                    "event": "note",
                    "message": "(2) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 289,
                    "column": 10,
                    "event": "note",
                    "message": "(3) calling 'xicalloc' from 'xizalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 302,
                    "column": 1,
                    "event": "note",
                    "message": "(4) entry to 'xicalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 304,
                    "column": 10,
                    "event": "note",
                    "message": "(5) inlined call to 'check_nonnull' from 'xicalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 35,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'xicalloc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 304,
                    "column": 10,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 304,
                    "column": 10,
                    "event": "note",
                    "message": "(8) inlined call to 'icalloc' from 'xicalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/ialloc.h",
                    "line": 106,
                    "column": 10,
                    "event": "note",
                    "message": "(9) 'xicalloc(s, 1)' leaks here; was allocated at (2)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  104|         s = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  105|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  106|->   return calloc (n, s);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  107|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  108|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 664,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/long-options.c",
                    "line": 76,
                    "event": "error[va_end_missing]",
                    "message": "va_list 'authors' was opened but not closed by va_end().",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   74|               version_etc_va (stdout, command_name, package, version, authors);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   75|               exit (EXIT_SUCCESS);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   76|->           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   77|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   78|           default:",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 664,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/long-options.c",
                    "line": 129,
                    "event": "error[va_end_missing]",
                    "message": "va_list 'authors' was opened but not closed by va_end().",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  127|               version_etc_va (stdout, command_name, package, version, authors);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  128|               exit (EXIT_SUCCESS);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  129|->           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  130|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  131|           default:",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 2,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 43,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/mbfile.h",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'unexpand'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/mbfile.h",
                    "line": 85,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc(max_column_width * 32)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 319,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 383,
                    "column": 3,
                    "event": "note",
                    "message": "(2) calling 'unexpand' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 107,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to 'unexpand'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 124,
                    "column": 6,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/mbfile.h",
                    "line": 253,
                    "column": 13,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 126,
                    "column": 3,
                    "event": "note",
                    "message": "in expansion of macro 'mbf_init'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 141,
                    "column": 19,
                    "event": "note",
                    "message": "(6) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/mbfile.h",
                    "line": 259,
                    "column": 28,
                    "event": "note",
                    "message": "(7) calling 'mbfile_multi_getc' from 'unexpand'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 186,
                    "column": 13,
                    "event": "note",
                    "message": "in expansion of macro 'mbf_getc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/mbfile.h",
                    "line": 78,
                    "column": 1,
                    "event": "note",
                    "message": "(8) entry to 'mbfile_multi_getc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/mbfile.h",
                    "line": 85,
                    "column": 6,
                    "event": "note",
                    "message": "(9) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/mbfile.h",
                    "line": 89,
                    "column": 10,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/mbfile.h",
                    "line": 259,
                    "column": 28,
                    "event": "note",
                    "message": "(11) returning to 'unexpand' from 'mbfile_multi_getc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 186,
                    "column": 13,
                    "event": "note",
                    "message": "in expansion of macro 'mbf_getc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 187,
                    "column": 16,
                    "event": "note",
                    "message": "(12) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/mbfile.h",
                    "line": 253,
                    "column": 13,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 189,
                    "column": 17,
                    "event": "note",
                    "message": "in expansion of macro 'mbf_init'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 192,
                    "column": 22,
                    "event": "note",
                    "message": "(14) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 203,
                    "column": 23,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/mbfile.h",
                    "line": 85,
                    "column": 10,
                    "event": "note",
                    "message": "(16) 'xmalloc(max_column_width * 32)' leaks here; was allocated at (6)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   83|     /* If EOF has already been seen, don't use getc.  This matters if",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   84|        mbf->fp is connected to an interactive tty.  */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   85|->   if (mbf->eof_seen)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   86|       goto eof;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   87|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 758,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/mini-gmp.c",
                    "line": 1513,
                    "event": "error[shiftTooManyBits]",
                    "message": "Shifting 64-bit value by 64 bits is undefined behaviour",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1511|   \t{",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1512|   \t  int LOCAL_GMP_LIMB_BITS = GMP_LIMB_BITS;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1513|-> \t  while (x >>= LOCAL_GMP_LIMB_BITS)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1514|   \t    {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1515|   \t      ++ r->_mp_size;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 758,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/mini-gmp.c",
                    "line": 1635,
                    "event": "error[shiftTooManyBits]",
                    "message": "Shifting 64-bit value by 64 bits is undefined behaviour",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1633|         n = GMP_MIN (n, 1 + (mp_size_t) (GMP_ULONG_BITS - 1) / GMP_LIMB_BITS);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1634|         while (--n >= 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1635|-> \tr = (r << LOCAL_GMP_LIMB_BITS) + u->_mp_d[n];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1636|         return r;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1637|       }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 562,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/mktime.c",
                    "line": 262,
                    "event": "error[returnDanglingLifetime]",
                    "message": "Returning pointer to local variable 'x' that will be invalid when returning.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  260|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  261|     __time64_t x = t;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  262|->   return convert (&x, tm);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  263|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  264|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/randint.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'randint_new'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/randint.c",
                    "line": 76,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'randint_new(randread_new(name,  bytes_bound))'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/randint.c",
                    "line": 84,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'randint_all_new'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randint.c",
                    "line": 87,
                    "column": 41,
                    "event": "note",
                    "message": "(2) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randint.c",
                    "line": 87,
                    "column": 20,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randint.c",
                    "line": 87,
                    "column": 20,
                    "event": "note",
                    "message": "(4) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randint.c",
                    "line": 87,
                    "column": 20,
                    "event": "note",
                    "message": "(5) calling 'randint_new' from 'randint_all_new'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randint.c",
                    "line": 71,
                    "column": 1,
                    "event": "note",
                    "message": "(6) entry to 'randint_new'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randint.c",
                    "line": 76,
                    "column": 10,
                    "event": "note",
                    "message": "(7) 'randint_new(randread_new(name,  bytes_bound))' leaks here; was allocated at (4)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   74|     s->source = source;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   75|     s->randnum = s->randmax = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   76|->   return s;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   77|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   78|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 146,
                    "column": 1,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'v1'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 126,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 128,
                    "column": 12,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 128,
                    "column": 12,
                    "event": "note",
                    "message": "(3) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 131,
                    "column": 6,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 137,
                    "column": 10,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 140,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 142,
                    "column": 8,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 142,
                    "column": 6,
                    "event": "note",
                    "message": "(8) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 145,
                    "column": 4,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 146,
                    "column": 1,
                    "event": "note",
                    "message": "(10) 'v1' leaks here; was allocated at (3)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  144|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  145|     v[i] = v1->val;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  146|-> }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  147|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  148|   static void",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'sparse_swap'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 146,
                    "column": 1,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'v2'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 126,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 131,
                    "column": 6,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 131,
                    "column": 6,
                    "event": "note",
                    "message": "(3) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 133,
                    "column": 12,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 133,
                    "column": 12,
                    "event": "note",
                    "message": "(5) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 140,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 142,
                    "column": 8,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 142,
                    "column": 6,
                    "event": "note",
                    "message": "(8) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 145,
                    "column": 4,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/randperm.c",
                    "line": 146,
                    "column": 1,
                    "event": "note",
                    "message": "(10) 'v2' leaks here; was allocated at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  144|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  145|     v[i] = v1->val;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  146|-> }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  147|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  148|   static void",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 3,
            "events": [
                {
                    "file_name": "coreutils-9.5/separate/lib/sys/stat.h",
                    "line": 54,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 23,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'fread_file'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 62,
                    "column": 57,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'fread_file(rpl_fopen(filename,  <unknown>), flags,  length)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 190,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'read_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 196,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 199,
                    "column": 13,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 202,
                    "column": 9,
                    "event": "note",
                    "message": "(4) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 202,
                    "column": 9,
                    "event": "note",
                    "message": "(5) calling 'fread_file' from 'read_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 52,
                    "column": 1,
                    "event": "note",
                    "message": "(6) entry to 'fread_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 62,
                    "column": 57,
                    "event": "note",
                    "message": "(7) 'fread_file(rpl_fopen(filename,  <unknown>), flags,  length)' leaks here; was allocated at (4)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   60|       struct stat st;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   61|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   62|->     if (fstat (fileno (stream), &st) >= 0 && S_ISREG (st.st_mode))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   63|         {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   64|           off_t pos = ftello (stream);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 82,
                    "column": 6,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'fread_file(rpl_fopen(filename,  <unknown>), flags,  length)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 190,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'read_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 196,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 199,
                    "column": 13,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 202,
                    "column": 9,
                    "event": "note",
                    "message": "(4) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 202,
                    "column": 9,
                    "event": "note",
                    "message": "(5) calling 'fread_file' from 'read_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 52,
                    "column": 1,
                    "event": "note",
                    "message": "(6) entry to 'fread_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 82,
                    "column": 6,
                    "event": "note",
                    "message": "(7) following 'true' branch (when 'buf' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 82,
                    "column": 6,
                    "event": "note",
                    "message": "(9) 'fread_file(rpl_fopen(filename,  <unknown>), flags,  length)' leaks here; was allocated at (4)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   80|     }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   81|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   82|->   if (!(buf = malloc (alloc)))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   83|       return NULL; /* errno is ENOMEM.  */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   84|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 104,
                    "column": 30,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'fread_file(rpl_fopen(filename,  <unknown>), flags,  length)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 190,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'read_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 196,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 199,
                    "column": 13,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 202,
                    "column": 9,
                    "event": "note",
                    "message": "(4) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 202,
                    "column": 9,
                    "event": "note",
                    "message": "(5) calling 'fread_file' from 'read_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 52,
                    "column": 1,
                    "event": "note",
                    "message": "(6) entry to 'fread_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 82,
                    "column": 6,
                    "event": "note",
                    "message": "(7) following 'false' branch (when 'buf' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 100,
                    "column": 16,
                    "event": "note",
                    "message": "(9) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 104,
                    "column": 30,
                    "event": "note",
                    "message": "(10) ...to here (11) 'fread_file(rpl_fopen(filename,  <unknown>), flags,  length)' leaks here; was allocated at (4)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  102|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  103|               /* Shrink the allocated memory if possible.  */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  104|->             if (size < alloc - 1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  105|                 {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  106|                   if (flags & RF_SENSITIVE)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 142,
                    "column": 43,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'fread_file(rpl_fopen(filename,  <unknown>), flags,  length)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 190,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'read_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 196,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 199,
                    "column": 13,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 202,
                    "column": 9,
                    "event": "note",
                    "message": "(4) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 202,
                    "column": 9,
                    "event": "note",
                    "message": "(5) calling 'fread_file' from 'read_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 52,
                    "column": 1,
                    "event": "note",
                    "message": "(6) entry to 'fread_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 82,
                    "column": 6,
                    "event": "note",
                    "message": "(7) following 'false' branch (when 'buf' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 97,
                    "column": 12,
                    "event": "note",
                    "message": "(9) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 136,
                    "column": 14,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 136,
                    "column": 14,
                    "event": "note",
                    "message": "(11) following 'false' branch (when 'alloc != 9223372036854775807')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 142,
                    "column": 43,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 142,
                    "column": 14,
                    "event": "note",
                    "message": "(13) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 143,
                    "column": 19,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 147,
                    "column": 14,
                    "event": "note",
                    "message": "(15) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 149,
                    "column": 25,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 150,
                    "column": 18,
                    "event": "note",
                    "message": "(17) following 'false' branch (when 'new_buf' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 156,
                    "column": 15,
                    "event": "note",
                    "message": "(18) inlined call to 'memcpy' from 'fread_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/bits/string_fortified.h",
                    "line": 29,
                    "column": 10,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'fread_file'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 94,
                    "column": 24,
                    "event": "note",
                    "message": "(20) inlined call to 'fread' from 'fread_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/bits/stdio2.h",
                    "line": 330,
                    "column": 6,
                    "event": "note",
                    "message": "(21) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/bits/stdio2.h",
                    "line": 331,
                    "column": 12,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'fread_file'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 97,
                    "column": 12,
                    "event": "note",
                    "message": "(23) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 38,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 99,
                    "column": 27,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 100,
                    "column": 16,
                    "event": "note",
                    "message": "(25) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 104,
                    "column": 30,
                    "event": "note",
                    "message": "(26) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 104,
                    "column": 16,
                    "event": "note",
                    "message": "(27) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 106,
                    "column": 27,
                    "event": "note",
                    "message": "(28) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 106,
                    "column": 20,
                    "event": "note",
                    "message": "(29) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 121,
                    "column": 41,
                    "event": "note",
                    "message": "(30) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 121,
                    "column": 41,
                    "event": "note",
                    "message": "(31) when 'realloc' succeeds, moving buffer",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 122,
                    "column": 24,
                    "event": "note",
                    "message": "(32) following 'true' branch (when 'smaller_buf' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 127,
                    "column": 16,
                    "event": "note",
                    "message": "(33) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/read-file.c",
                    "line": 142,
                    "column": 43,
                    "event": "note",
                    "message": "(34) 'fread_file(rpl_fopen(filename,  <unknown>), flags,  length)' leaks here; was allocated at (4)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  140|               }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  141|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  142|->           if (alloc < PTRDIFF_MAX - alloc / 2)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  143|               alloc = alloc + alloc / 2;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  144|             else",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/readutmp.c",
                    "line": 249,
                    "column": 8,
                    "event": "warning[core.NullDereference]",
                    "message": "Dereference of null pointer",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.c",
                    "line": 951,
                    "column": 10,
                    "event": "note",
                    "message": "Calling 'read_utmp_from_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.c",
                    "line": 320,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.c",
                    "line": 321,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.c",
                    "line": 351,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.c",
                    "line": 351,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.c",
                    "line": 362,
                    "column": 11,
                    "event": "note",
                    "message": "Calling 'add_utmp'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.c",
                    "line": 237,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'avail' is >= 'needed'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.c",
                    "line": 237,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.c",
                    "line": 249,
                    "column": 4,
                    "event": "note",
                    "message": "Null pointer value stored to 'p'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.c",
                    "line": 249,
                    "column": 8,
                    "event": "note",
                    "message": "Dereference of null pointer",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  247|     char *stringlim = (char *) a.utmp + a.alloc_bytes;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  248|     char *p = stringlim - a.string_bytes;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  249|->   *--p = '\\0'; /* NUL-terminate ut->ut_user */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  250|     ut->ut_user = p = memcpy (p - user_len, user, user_len);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  251|     *--p = '\\0'; /* NUL-terminate ut->ut_id */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 2,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 32,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'tsort'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/stdio--.h",
                    "line": 30,
                    "column": 18,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xzalloc(56)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 440,
                    "column": 22,
                    "event": "note",
                    "message": "in expansion of macro 'freopen'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 531,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 545,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 551,
                    "column": 3,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 551,
                    "column": 3,
                    "event": "note",
                    "message": "(4) calling 'tsort' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 429,
                    "column": 1,
                    "event": "note",
                    "message": "(5) entry to 'tsort'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 438,
                    "column": 23,
                    "event": "note",
                    "message": "(6) inlined call to 'new_item' from 'tsort'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 104,
                    "column": 20,
                    "event": "note",
                    "message": "(7) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'tsort'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 440,
                    "column": 6,
                    "event": "note",
                    "message": "(8) following 'true' branch (when the strings are non-equal)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/stdio--.h",
                    "line": 30,
                    "column": 18,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 440,
                    "column": 22,
                    "event": "note",
                    "message": "in expansion of macro 'freopen'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/stdio--.h",
                    "line": 30,
                    "column": 18,
                    "event": "note",
                    "message": "(10) 'xzalloc(56)' leaks here; was allocated at (7)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 440,
                    "column": 22,
                    "event": "note",
                    "message": "in expansion of macro 'freopen'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   28|   #if GNULIB_FREOPEN_SAFER",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   29|   # undef freopen",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   30|-> # define freopen freopen_safer",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   31|   #endif",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   32|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'tzfree'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 68,
                    "column": 64,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'tzalloc(getenv(\"TZ\"))'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 27,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/time.h",
                    "line": 1034,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'mktime_z'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 287,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch (when 'tz' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 291,
                    "column": 27,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 291,
                    "column": 27,
                    "event": "note",
                    "message": "(4) calling 'set_tz' from 'mktime_z'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 206,
                    "column": 1,
                    "event": "note",
                    "message": "(5) entry to 'set_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 209,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 215,
                    "column": 27,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 215,
                    "column": 27,
                    "event": "note",
                    "message": "(8) calling 'tzalloc' from 'set_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/time.h",
                    "line": 1008,
                    "column": 1,
                    "event": "note",
                    "message": "(9) entry to 'tzalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 69,
                    "column": 19,
                    "event": "note",
                    "message": "(10) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 70,
                    "column": 6,
                    "event": "note",
                    "message": "(11) assuming 'tz' is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 70,
                    "column": 6,
                    "event": "note",
                    "message": "(12) following 'true' branch (when 'tz' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 72,
                    "column": 16,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 78,
                    "column": 10,
                    "event": "note",
                    "message": "(14) following 'false' branch (when 'name' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 81,
                    "column": 10,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 215,
                    "column": 27,
                    "event": "note",
                    "message": "(16) returning to 'set_tz' from 'tzalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 216,
                    "column": 10,
                    "event": "note",
                    "message": "(17) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 218,
                    "column": 13,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 218,
                    "column": 13,
                    "event": "note",
                    "message": "(19) calling 'change_env' from 'set_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 193,
                    "column": 1,
                    "event": "note",
                    "message": "(20) entry to 'change_env'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 195,
                    "column": 7,
                    "event": "note",
                    "message": "(21) calling 'setenv_TZ' from 'change_env'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 184,
                    "column": 1,
                    "event": "note",
                    "message": "(22) entry to 'setenv_TZ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 186,
                    "column": 36,
                    "event": "note",
                    "message": "(23) following 'true' branch (when 'tz' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 186,
                    "column": 15,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 195,
                    "column": 7,
                    "event": "note",
                    "message": "(25) returning to 'change_env' from 'setenv_TZ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 218,
                    "column": 13,
                    "event": "note",
                    "message": "(26) returning to 'set_tz' from 'change_env'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 218,
                    "column": 10,
                    "event": "note",
                    "message": "(27) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 29,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 220,
                    "column": 29,
                    "event": "note",
                    "message": "(28) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 221,
                    "column": 11,
                    "event": "note",
                    "message": "(29) calling 'tzfree' from 'set_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/time.h",
                    "line": 1014,
                    "column": 1,
                    "event": "note",
                    "message": "(30) entry to 'tzfree'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 162,
                    "column": 6,
                    "event": "note",
                    "message": "(31) following 'false' branch (when 'tz == 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 169,
                    "column": 1,
                    "event": "note",
                    "message": "(32) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 68,
                    "column": 64,
                    "event": "note",
                    "message": "(33) 'tzalloc(getenv(\"TZ\"))' leaks here; was allocated at (10)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   66|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   67|     size_t name_size = name ? strlen (name) + 1 : 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   68|->   size_t abbr_size = name_size < ABBR_SIZE_MIN ? ABBR_SIZE_MIN : name_size + 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   69|     timezone_t tz = malloc (FLEXSIZEOF (struct tm_zone, abbrs, abbr_size));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   70|     if (tz)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'mktime_z'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 211,
                    "column": 12,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'set_tz(tz)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/time.h",
                    "line": 1034,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'mktime_z'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 287,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch (when 'tz' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 291,
                    "column": 27,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 291,
                    "column": 27,
                    "event": "note",
                    "message": "(4) calling 'set_tz' from 'mktime_z'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 206,
                    "column": 1,
                    "event": "note",
                    "message": "(5) entry to 'set_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 209,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 215,
                    "column": 27,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 215,
                    "column": 27,
                    "event": "note",
                    "message": "(8) calling 'tzalloc' from 'set_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/time.h",
                    "line": 1008,
                    "column": 1,
                    "event": "note",
                    "message": "(9) entry to 'tzalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 69,
                    "column": 19,
                    "event": "note",
                    "message": "(10) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 70,
                    "column": 6,
                    "event": "note",
                    "message": "(11) assuming 'tz' is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 70,
                    "column": 6,
                    "event": "note",
                    "message": "(12) following 'true' branch (when 'tz' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 72,
                    "column": 16,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 78,
                    "column": 10,
                    "event": "note",
                    "message": "(14) following 'false' branch (when 'name' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 81,
                    "column": 10,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 215,
                    "column": 27,
                    "event": "note",
                    "message": "(16) returning to 'set_tz' from 'tzalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 216,
                    "column": 10,
                    "event": "note",
                    "message": "(17) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 218,
                    "column": 13,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 218,
                    "column": 13,
                    "event": "note",
                    "message": "(19) calling 'change_env' from 'set_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 193,
                    "column": 1,
                    "event": "note",
                    "message": "(20) entry to 'change_env'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 195,
                    "column": 7,
                    "event": "note",
                    "message": "(21) calling 'setenv_TZ' from 'change_env'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 184,
                    "column": 1,
                    "event": "note",
                    "message": "(22) entry to 'setenv_TZ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 186,
                    "column": 36,
                    "event": "note",
                    "message": "(23) following 'true' branch (when 'tz' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 186,
                    "column": 15,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 195,
                    "column": 7,
                    "event": "note",
                    "message": "(25) returning to 'change_env' from 'setenv_TZ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 218,
                    "column": 13,
                    "event": "note",
                    "message": "(26) returning to 'set_tz' from 'change_env'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 218,
                    "column": 10,
                    "event": "note",
                    "message": "(27) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(28) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 291,
                    "column": 27,
                    "event": "note",
                    "message": "(29) returning to 'mktime_z' from 'set_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 292,
                    "column": 10,
                    "event": "note",
                    "message": "(30) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 295,
                    "column": 27,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 211,
                    "column": 12,
                    "event": "note",
                    "message": "(32) 'set_tz(tz)' leaks here; was allocated at (10)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  209|     if (env_tz",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  210|         ? tz->tz_is_set && strcmp (tz->abbrs, env_tz) == 0",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  211|->       : !tz->tz_is_set)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  212|       return local_tz;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  213|     else",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 222,
                    "column": 11,
                    "event": "warning[unix.Malloc]",
                    "message": "Potential leak of memory pointed to by 'old_tz'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "/usr/include/errno.h",
                    "line": 38,
                    "column": 18,
                    "event": "note",
                    "message": "expanded from macro 'errno'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 287,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'tz' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 287,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 291,
                    "column": 27,
                    "event": "note",
                    "message": "Calling 'set_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 209,
                    "column": 7,
                    "event": "note",
                    "message": "'env_tz' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 209,
                    "column": 7,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 211,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming field 'tz_is_set' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 209,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 215,
                    "column": 27,
                    "event": "note",
                    "message": "Calling 'tzalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 67,
                    "column": 22,
                    "event": "note",
                    "message": "'name' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 67,
                    "column": 22,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 68,
                    "column": 22,
                    "event": "note",
                    "message": "'name_size' is < ABBR_SIZE_MIN",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 68,
                    "column": 22,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 69,
                    "column": 19,
                    "event": "note",
                    "message": "Memory is allocated",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 70,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'tz' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 70,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 78,
                    "column": 11,
                    "event": "note",
                    "message": "'name' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 78,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 215,
                    "column": 27,
                    "event": "note",
                    "message": "Returned allocated memory",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 216,
                    "column": 12,
                    "event": "note",
                    "message": "'old_tz' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 216,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 218,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 221,
                    "column": 11,
                    "event": "note",
                    "message": "Calling 'tzfree'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 162,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'tz' is equal to 'local_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 162,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 169,
                    "column": 1,
                    "event": "note",
                    "message": "Returning without deallocating memory or storing the pointer for later deallocation",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 221,
                    "column": 11,
                    "event": "note",
                    "message": "Returning from 'tzfree'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 222,
                    "column": 11,
                    "event": "note",
                    "message": "Potential leak of memory pointed to by 'old_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/errno.h",
                    "line": 38,
                    "column": 18,
                    "event": "note",
                    "message": "expanded from macro 'errno'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  220|             int saved_errno = errno;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  221|             tzfree (old_tz);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  222|->           errno = saved_errno;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  223|             return NULL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  224|           }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 276,
                    "column": 37,
                    "event": "warning[unix.Malloc]",
                    "message": "Potential leak of memory pointed to by 'old_tz'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 268,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'tz' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 268,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 272,
                    "column": 27,
                    "event": "note",
                    "message": "Calling 'set_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 209,
                    "column": 7,
                    "event": "note",
                    "message": "'env_tz' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 209,
                    "column": 7,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 211,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming field 'tz_is_set' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 209,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 215,
                    "column": 27,
                    "event": "note",
                    "message": "Calling 'tzalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 67,
                    "column": 22,
                    "event": "note",
                    "message": "'name' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 67,
                    "column": 22,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 68,
                    "column": 22,
                    "event": "note",
                    "message": "'name_size' is < ABBR_SIZE_MIN",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 68,
                    "column": 22,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 69,
                    "column": 19,
                    "event": "note",
                    "message": "Memory is allocated",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 70,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'tz' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 70,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 78,
                    "column": 11,
                    "event": "note",
                    "message": "'name' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 78,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 215,
                    "column": 27,
                    "event": "note",
                    "message": "Returned allocated memory",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 216,
                    "column": 12,
                    "event": "note",
                    "message": "'old_tz' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 216,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 218,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 272,
                    "column": 27,
                    "event": "note",
                    "message": "Returned allocated memory",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 273,
                    "column": 11,
                    "event": "note",
                    "message": "'old_tz' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 273,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 275,
                    "column": 29,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 275,
                    "column": 49,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 276,
                    "column": 15,
                    "event": "note",
                    "message": "Calling 'revert_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 235,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'tz' is equal to 'local_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 235,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 276,
                    "column": 15,
                    "event": "note",
                    "message": "Returning from 'revert_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 276,
                    "column": 15,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 276,
                    "column": 37,
                    "event": "note",
                    "message": "Potential leak of memory pointed to by 'old_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  274|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  275|             bool abbr_saved = localtime_r (t, tm) && save_abbr (tz, tm);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  276|->           if (revert_tz (old_tz) && abbr_saved)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  277|               return tm;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  278|           }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 308,
                    "column": 37,
                    "event": "warning[unix.Malloc]",
                    "message": "Potential leak of memory pointed to by 'old_tz'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 287,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'tz' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 287,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 291,
                    "column": 27,
                    "event": "note",
                    "message": "Calling 'set_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 209,
                    "column": 7,
                    "event": "note",
                    "message": "'env_tz' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 209,
                    "column": 7,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 211,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming field 'tz_is_set' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 209,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 215,
                    "column": 27,
                    "event": "note",
                    "message": "Calling 'tzalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 67,
                    "column": 22,
                    "event": "note",
                    "message": "'name' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 67,
                    "column": 22,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 68,
                    "column": 22,
                    "event": "note",
                    "message": "'name_size' is < ABBR_SIZE_MIN",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 68,
                    "column": 22,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 69,
                    "column": 19,
                    "event": "note",
                    "message": "Memory is allocated",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 70,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'tz' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 70,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 78,
                    "column": 11,
                    "event": "note",
                    "message": "'name' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 78,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 215,
                    "column": 27,
                    "event": "note",
                    "message": "Returned allocated memory",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 216,
                    "column": 12,
                    "event": "note",
                    "message": "'old_tz' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 216,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 218,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 291,
                    "column": 27,
                    "event": "note",
                    "message": "Returned allocated memory",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 292,
                    "column": 11,
                    "event": "note",
                    "message": "'old_tz' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 292,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 304,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming 0 is > field 'tm_yday'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 306,
                    "column": 16,
                    "event": "note",
                    "message": "'ok' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 306,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 308,
                    "column": 15,
                    "event": "note",
                    "message": "Calling 'revert_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 235,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'tz' is equal to 'local_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 235,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 308,
                    "column": 15,
                    "event": "note",
                    "message": "Returning from 'revert_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 308,
                    "column": 15,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/time_rz.c",
                    "line": 308,
                    "column": 37,
                    "event": "note",
                    "message": "Potential leak of memory pointed to by 'old_tz'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  306|             ok = ok && save_abbr (tz, &tm_1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  307|   #endif",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  308|->           if (revert_tz (old_tz) && ok)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  309|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  310|                 *tm = tm_1;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'xmalloc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 45,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc(n)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 55,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'xcharalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 22,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xalloc.h",
                    "line": 119,
                    "column": 31,
                    "event": "note",
                    "message": "(2) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 57,
                    "column": 10,
                    "event": "note",
                    "message": "in expansion of macro 'XNMALLOC'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xalloc.h",
                    "line": 119,
                    "column": 31,
                    "event": "note",
                    "message": "(3) calling 'xmalloc' from 'xcharalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 57,
                    "column": 10,
                    "event": "note",
                    "message": "in expansion of macro 'XNMALLOC'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 43,
                    "column": 1,
                    "event": "note",
                    "message": "(4) entry to 'xmalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 45,
                    "column": 10,
                    "event": "note",
                    "message": "(5) inlined call to 'check_nonnull' from 'xmalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 35,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'xmalloc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 45,
                    "column": 10,
                    "event": "note",
                    "message": "(7) ...to here (8) 'xmalloc(n)' leaks here; was allocated at (2)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   43|   xmalloc (size_t s)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   44|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   45|->   return check_nonnull (malloc (s));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   46|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   47|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 45,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc(s)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 312,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'xmemdup'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 314,
                    "column": 10,
                    "event": "note",
                    "message": "(2) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 314,
                    "column": 10,
                    "event": "note",
                    "message": "(3) calling 'xmalloc' from 'xmemdup'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 43,
                    "column": 1,
                    "event": "note",
                    "message": "(4) entry to 'xmalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 45,
                    "column": 10,
                    "event": "note",
                    "message": "(5) inlined call to 'check_nonnull' from 'xmalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 35,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'xmalloc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 45,
                    "column": 10,
                    "event": "note",
                    "message": "(7) ...to here (8) 'xmalloc(s)' leaks here; was allocated at (2)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   43|   xmalloc (size_t s)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   44|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   45|->   return check_nonnull (malloc (s));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   46|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   47|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'xcalloc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 298,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xcalloc(s, 1)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 281,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'xzalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 283,
                    "column": 10,
                    "event": "note",
                    "message": "(2) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 283,
                    "column": 10,
                    "event": "note",
                    "message": "(3) calling 'xcalloc' from 'xzalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 296,
                    "column": 1,
                    "event": "note",
                    "message": "(4) entry to 'xcalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 298,
                    "column": 10,
                    "event": "note",
                    "message": "(5) inlined call to 'check_nonnull' from 'xcalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 35,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'xcalloc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 298,
                    "column": 10,
                    "event": "note",
                    "message": "(7) ...to here (8) 'xcalloc(s, 1)' leaks here; was allocated at (2)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  296|   xcalloc (size_t n, size_t s)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  297|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  298|->   return check_nonnull (calloc (n, s));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  299|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  300|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'xmemdup'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 314,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmemdup(string,  strlen(string) + 1)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 337,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'xstrdup'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 339,
                    "column": 10,
                    "event": "note",
                    "message": "(2) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 339,
                    "column": 10,
                    "event": "note",
                    "message": "(3) calling 'xmemdup' from 'xstrdup'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 312,
                    "column": 1,
                    "event": "note",
                    "message": "(4) entry to 'xmemdup'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 314,
                    "column": 10,
                    "event": "note",
                    "message": "(5) calling 'xmalloc' from 'xmemdup'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 43,
                    "column": 1,
                    "event": "note",
                    "message": "(6) entry to 'xmalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 45,
                    "column": 10,
                    "event": "note",
                    "message": "(7) inlined call to 'check_nonnull' from 'xmalloc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 35,
                    "column": 6,
                    "event": "note",
                    "message": "(8) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'xmemdup'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 45,
                    "column": 10,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/xmalloc.c",
                    "line": 314,
                    "column": 10,
                    "event": "note",
                    "message": "(10) returning to 'xmemdup' from 'xmalloc' (11) 'xmemdup(string,  strlen(string) + 1)' leaks here; was allocated at (2)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  312|   xmemdup (void const *p, size_t s)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  313|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  314|->   return memcpy (xmalloc (s), p, s);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  315|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  316|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'do_decode'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 239,
                    "column": 22,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc(4200)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 92,
                    "column": 46,
                    "event": "note",
                    "message": "in definition of macro 'fread'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1158,
                    "column": 31,
                    "event": "note",
                    "message": "in expansion of macro 'BASE_LENGTH'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1143,
                    "column": 12,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 239,
                    "column": 22,
                    "event": "note",
                    "message": "(2) 'xmalloc(4200)' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 92,
                    "column": 46,
                    "event": "note",
                    "message": "in definition of macro 'fread'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1158,
                    "column": 31,
                    "event": "note",
                    "message": "in expansion of macro 'BASE_LENGTH'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  237|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  238|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  239|-> # define BASE_LENGTH base_length",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  240|   # define REQUIRED_PADDING required_padding",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  241|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 3,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 254,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 25,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'do_encode'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1107,
                    "column": 52,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc((long unsigned int)base_length(30720))'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 92,
                    "column": 46,
                    "event": "note",
                    "message": "in definition of macro 'fread'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1091,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'do_encode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1098,
                    "column": 12,
                    "event": "note",
                    "message": "(2) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1112,
                    "column": 10,
                    "event": "note",
                    "message": "(3) following 'false' branch (when 'sum <= 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 50,
                    "column": 19,
                    "event": "note",
                    "message": "(4) inlined call to 'feof_unlocked' from 'do_encode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "in expansion of macro 'feof'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/bits/stdio.h",
                    "line": 130,
                    "column": 10,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'do_encode'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1107,
                    "column": 52,
                    "event": "note",
                    "message": "(6) 'xmalloc((long unsigned int)base_length(30720))' leaks here; was allocated at (2)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 92,
                    "column": 46,
                    "event": "note",
                    "message": "in definition of macro 'fread'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1105|         do",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1106|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1107|->           n = fread (inbuf + sum, 1, ENC_BLOCKSIZE - sum, in);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1108|             sum += n;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1109|           }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 3,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 254,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 25,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'do_encode'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1107,
                    "column": 52,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc(40960)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 92,
                    "column": 46,
                    "event": "note",
                    "message": "in definition of macro 'fread'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1217,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1367,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1373,
                    "column": 6,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1392,
                    "column": 6,
                    "event": "note",
                    "message": "(4) following 'false' branch (when 'decode == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1395,
                    "column": 5,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1395,
                    "column": 5,
                    "event": "note",
                    "message": "(6) calling 'do_encode' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1091,
                    "column": 1,
                    "event": "note",
                    "message": "(7) entry to 'do_encode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1098,
                    "column": 12,
                    "event": "note",
                    "message": "(8) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1112,
                    "column": 10,
                    "event": "note",
                    "message": "(9) following 'false' branch (when 'sum <= 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 50,
                    "column": 19,
                    "event": "note",
                    "message": "(10) inlined call to 'feof_unlocked' from 'do_encode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "in expansion of macro 'feof'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/bits/stdio.h",
                    "line": 130,
                    "column": 10,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'do_encode'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1107,
                    "column": 52,
                    "event": "note",
                    "message": "(12) 'xmalloc(40960)' leaks here; was allocated at (8)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 92,
                    "column": 46,
                    "event": "note",
                    "message": "in definition of macro 'fread'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1105|         do",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1106|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1107|->           n = fread (inbuf + sum, 1, ENC_BLOCKSIZE - sum, in);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1108|             sum += n;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1109|           }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 3,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 254,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 25,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'do_encode'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1107,
                    "column": 52,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc(49152)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 92,
                    "column": 46,
                    "event": "note",
                    "message": "in definition of macro 'fread'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1217,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1367,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1373,
                    "column": 6,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1392,
                    "column": 6,
                    "event": "note",
                    "message": "(4) following 'false' branch (when 'decode == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1395,
                    "column": 5,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1395,
                    "column": 5,
                    "event": "note",
                    "message": "(6) calling 'do_encode' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1091,
                    "column": 1,
                    "event": "note",
                    "message": "(7) entry to 'do_encode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1098,
                    "column": 12,
                    "event": "note",
                    "message": "(8) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1112,
                    "column": 10,
                    "event": "note",
                    "message": "(9) following 'false' branch (when 'sum <= 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 50,
                    "column": 19,
                    "event": "note",
                    "message": "(10) inlined call to 'feof_unlocked' from 'do_encode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "in expansion of macro 'feof'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/bits/stdio.h",
                    "line": 130,
                    "column": 10,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'do_encode'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1107,
                    "column": 52,
                    "event": "note",
                    "message": "(12) 'xmalloc(49152)' leaks here; was allocated at (8)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 92,
                    "column": 46,
                    "event": "note",
                    "message": "in definition of macro 'fread'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1105|         do",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1106|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1107|->           n = fread (inbuf + sum, 1, ENC_BLOCKSIZE - sum, in);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1108|             sum += n;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1109|           }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'do_decode'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1158,
                    "column": 59,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc(3072)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 92,
                    "column": 46,
                    "event": "note",
                    "message": "in definition of macro 'fread'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1143,
                    "column": 12,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1158,
                    "column": 59,
                    "event": "note",
                    "message": "(2) 'xmalloc(3072)' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 92,
                    "column": 46,
                    "event": "note",
                    "message": "in definition of macro 'fread'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1156|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1157|             idx_t n = fread (inbuf + sum,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1158|->                            1, BASE_LENGTH (DEC_BLOCKSIZE) - sum, in);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1159|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1160|             if (ignore_garbage)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'do_decode'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1158,
                    "column": 59,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc(5120)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 92,
                    "column": 46,
                    "event": "note",
                    "message": "in definition of macro 'fread'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1143,
                    "column": 12,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/basenc.c",
                    "line": 1158,
                    "column": 59,
                    "event": "note",
                    "message": "(2) 'xmalloc(5120)' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 92,
                    "column": 46,
                    "event": "note",
                    "message": "in definition of macro 'fread'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1156|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1157|             idx_t n = fread (inbuf + sum,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1158|->                            1, BASE_LENGTH (DEC_BLOCKSIZE) - sum, in);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1159|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1160|             if (ignore_garbage)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 457,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/blake2/blake2b-ref.c",
                    "line": 96,
                    "event": "warning[uninitvar]",
                    "message": "Uninitialized variable: P->digest_length",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   94|       S->h[i] ^= load64( p + sizeof( S->h[i] ) * i );",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   95|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   96|->   S->outlen = P->digest_length;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   97|     return 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   98|   }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'uid_to_name'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 84,
                    "column": 19,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'uid_to_name(*file_stats.st_uid)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 283,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'change_file_owner'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 483,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 486,
                    "column": 20,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 490,
                    "column": 19,
                    "event": "note",
                    "message": "(4) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 494,
                    "column": 14,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 63,
                    "event": "note",
                    "message": "(6) following 'true' branch (when 'file_stats' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 53,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 30,
                    "event": "note",
                    "message": "(8) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 30,
                    "event": "note",
                    "message": "(9) calling 'uid_to_name' from 'change_file_owner'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 114,
                    "column": 1,
                    "event": "note",
                    "message": "(10) entry to 'uid_to_name'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 117,
                    "column": 39,
                    "event": "note",
                    "message": "(11) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 117,
                    "column": 41,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 84,
                    "column": 19,
                    "event": "note",
                    "message": "(13) 'uid_to_name(*file_stats.st_uid)' leaks here; was allocated at (8)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   82|     char buf[INT_BUFSIZE_BOUND (intmax_t)];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   83|     return xstrdup (TYPE_SIGNED (uid_t) ? imaxtostr (uid, buf)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   84|->                   : umaxtostr (uid, buf));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   85|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   86|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'gid_to_name'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 95,
                    "column": 19,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'gid_to_name(*file_stats.st_gid)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 283,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'change_file_owner'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 483,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 486,
                    "column": 20,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 490,
                    "column": 19,
                    "event": "note",
                    "message": "(4) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 494,
                    "column": 14,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 63,
                    "event": "note",
                    "message": "(6) following 'true' branch (when 'file_stats' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 53,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 30,
                    "event": "note",
                    "message": "(8) calling 'uid_to_name' from 'change_file_owner'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 114,
                    "column": 1,
                    "event": "note",
                    "message": "(9) entry to 'uid_to_name'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 117,
                    "column": 39,
                    "event": "note",
                    "message": "(10) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 117,
                    "column": 28,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 30,
                    "event": "note",
                    "message": "(12) returning to 'change_file_owner' from 'uid_to_name'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 500,
                    "column": 30,
                    "event": "note",
                    "message": "(13) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 500,
                    "column": 30,
                    "event": "note",
                    "message": "(14) calling 'gid_to_name' from 'change_file_owner'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 103,
                    "column": 1,
                    "event": "note",
                    "message": "(15) entry to 'gid_to_name'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 106,
                    "column": 39,
                    "event": "note",
                    "message": "(16) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 106,
                    "column": 41,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 95,
                    "column": 19,
                    "event": "note",
                    "message": "(18) 'gid_to_name(*file_stats.st_gid)' leaks here; was allocated at (13)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   93|     char buf[INT_BUFSIZE_BOUND (intmax_t)];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   94|     return xstrdup (TYPE_SIGNED (gid_t) ? imaxtostr (gid, buf)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   95|->                   : umaxtostr (gid, buf));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   96|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   97|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 106,
                    "column": 28,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'gid_to_name(*file_stats.st_gid)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 283,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'change_file_owner'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 483,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 486,
                    "column": 20,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 490,
                    "column": 19,
                    "event": "note",
                    "message": "(4) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 494,
                    "column": 14,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 63,
                    "event": "note",
                    "message": "(6) following 'true' branch (when 'file_stats' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 53,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 30,
                    "event": "note",
                    "message": "(8) calling 'uid_to_name' from 'change_file_owner'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 114,
                    "column": 1,
                    "event": "note",
                    "message": "(9) entry to 'uid_to_name'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 117,
                    "column": 39,
                    "event": "note",
                    "message": "(10) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 117,
                    "column": 28,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 30,
                    "event": "note",
                    "message": "(12) returning to 'change_file_owner' from 'uid_to_name'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 500,
                    "column": 30,
                    "event": "note",
                    "message": "(13) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 500,
                    "column": 30,
                    "event": "note",
                    "message": "(14) calling 'gid_to_name' from 'change_file_owner'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 103,
                    "column": 1,
                    "event": "note",
                    "message": "(15) entry to 'gid_to_name'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 106,
                    "column": 39,
                    "event": "note",
                    "message": "(16) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 106,
                    "column": 28,
                    "event": "note",
                    "message": "(17) ...to here (18) 'gid_to_name(*file_stats.st_gid)' leaks here; was allocated at (13)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  104|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  105|     struct group *grp = getgrgid (gid);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  106|->   return grp ? xstrdup (grp->gr_name) : gid_to_str (gid);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  107|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  108|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'uid_to_name'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 117,
                    "column": 28,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'uid_to_name(*file_stats.st_uid)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 283,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'change_file_owner'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 483,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 486,
                    "column": 20,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 490,
                    "column": 19,
                    "event": "note",
                    "message": "(4) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 494,
                    "column": 14,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 63,
                    "event": "note",
                    "message": "(6) following 'true' branch (when 'file_stats' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 53,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 30,
                    "event": "note",
                    "message": "(8) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 30,
                    "event": "note",
                    "message": "(9) calling 'uid_to_name' from 'change_file_owner'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 114,
                    "column": 1,
                    "event": "note",
                    "message": "(10) entry to 'uid_to_name'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 117,
                    "column": 39,
                    "event": "note",
                    "message": "(11) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 117,
                    "column": 28,
                    "event": "note",
                    "message": "(12) ...to here (13) 'uid_to_name(*file_stats.st_uid)' leaks here; was allocated at (8)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  115|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  116|     struct passwd *pwd = getpwuid (uid);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  117|->   return pwd ? xstrdup (pwd->pw_name) : uid_to_str (uid);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  118|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  119|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'describe_change'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 171,
                    "column": 3,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'user_group_str(<unknown>,  <unknown>)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 535,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'chown_files'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 556,
                    "column": 10,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 568,
                    "column": 13,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 568,
                    "column": 13,
                    "event": "note",
                    "message": "(4) calling 'change_file_owner' from 'chown_files'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 283,
                    "column": 1,
                    "event": "note",
                    "message": "(5) entry to 'change_file_owner'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 414,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch (when 'do_chown == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 483,
                    "column": 12,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 483,
                    "column": 6,
                    "event": "note",
                    "message": "(8) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 486,
                    "column": 20,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 487,
                    "column": 10,
                    "event": "note",
                    "message": "(10) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 490,
                    "column": 19,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 490,
                    "column": 19,
                    "event": "note",
                    "message": "(12) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 494,
                    "column": 14,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 494,
                    "column": 14,
                    "event": "note",
                    "message": "(14) following 'false' branch (when 'ok == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 63,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 63,
                    "event": "note",
                    "message": "(16) following 'false' branch (when 'file_stats' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 501,
                    "column": 32,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 502,
                    "column": 46,
                    "event": "note",
                    "message": "(18) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 504,
                    "column": 32,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 505,
                    "column": 47,
                    "event": "note",
                    "message": "(20) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 507,
                    "column": 11,
                    "event": "note",
                    "message": "(21) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 507,
                    "column": 11,
                    "event": "note",
                    "message": "(22) calling 'describe_change' from 'change_file_owner'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 152,
                    "column": 1,
                    "event": "note",
                    "message": "(23) entry to 'describe_change'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 160,
                    "column": 6,
                    "event": "note",
                    "message": "(24) following 'false' branch (when 'changed != 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 167,
                    "column": 10,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 167,
                    "column": 10,
                    "event": "note",
                    "message": "(26) calling 'user_group_str' from 'describe_change'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 123,
                    "column": 1,
                    "event": "note",
                    "message": "(27) entry to 'user_group_str'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 127,
                    "column": 6,
                    "event": "note",
                    "message": "(28) following 'true' branch (when 'user' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 129,
                    "column": 10,
                    "event": "note",
                    "message": "(29) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 129,
                    "column": 10,
                    "event": "note",
                    "message": "(30) following 'true' branch (when 'group' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 167,
                    "column": 10,
                    "event": "note",
                    "message": "(32) returning to 'describe_change' from 'user_group_str'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 168,
                    "column": 14,
                    "event": "note",
                    "message": "(33) calling 'user_group_str' from 'describe_change'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 123,
                    "column": 1,
                    "event": "note",
                    "message": "(34) entry to 'user_group_str'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 127,
                    "column": 6,
                    "event": "note",
                    "message": "(35) following 'true' branch (when 'user' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 129,
                    "column": 10,
                    "event": "note",
                    "message": "(36) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 129,
                    "column": 10,
                    "event": "note",
                    "message": "(37) following 'false' branch (when 'group' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 136,
                    "column": 18,
                    "event": "note",
                    "message": "(38) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 136,
                    "column": 18,
                    "event": "note",
                    "message": "(39) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 168,
                    "column": 14,
                    "event": "note",
                    "message": "(40) returning to 'describe_change' from 'user_group_str'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 171,
                    "column": 3,
                    "event": "note",
                    "message": "(41) 'user_group_str(<unknown>,  <unknown>)' leaks here; was allocated at (39)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  169|                                group ? old_group : nullptr);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  170|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  171|->   switch (changed)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  172|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  173|       case CH_SUCCEEDED:",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 179,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'user_group_str(<unknown>,  <unknown>)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 535,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'chown_files'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 556,
                    "column": 10,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 568,
                    "column": 13,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 568,
                    "column": 13,
                    "event": "note",
                    "message": "(4) calling 'change_file_owner' from 'chown_files'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 283,
                    "column": 1,
                    "event": "note",
                    "message": "(5) entry to 'change_file_owner'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 414,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch (when 'do_chown == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 483,
                    "column": 12,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 483,
                    "column": 6,
                    "event": "note",
                    "message": "(8) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 486,
                    "column": 20,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 487,
                    "column": 10,
                    "event": "note",
                    "message": "(10) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 490,
                    "column": 19,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 490,
                    "column": 19,
                    "event": "note",
                    "message": "(12) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 494,
                    "column": 14,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 494,
                    "column": 14,
                    "event": "note",
                    "message": "(14) following 'false' branch (when 'ok == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 63,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 498,
                    "column": 63,
                    "event": "note",
                    "message": "(16) following 'false' branch (when 'file_stats' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 501,
                    "column": 32,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 502,
                    "column": 46,
                    "event": "note",
                    "message": "(18) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 504,
                    "column": 32,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 505,
                    "column": 47,
                    "event": "note",
                    "message": "(20) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 507,
                    "column": 11,
                    "event": "note",
                    "message": "(21) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 507,
                    "column": 11,
                    "event": "note",
                    "message": "(22) calling 'describe_change' from 'change_file_owner'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 152,
                    "column": 1,
                    "event": "note",
                    "message": "(23) entry to 'describe_change'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 160,
                    "column": 6,
                    "event": "note",
                    "message": "(24) following 'false' branch (when 'changed != 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 167,
                    "column": 10,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 167,
                    "column": 10,
                    "event": "note",
                    "message": "(26) calling 'user_group_str' from 'describe_change'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 123,
                    "column": 1,
                    "event": "note",
                    "message": "(27) entry to 'user_group_str'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 127,
                    "column": 6,
                    "event": "note",
                    "message": "(28) following 'true' branch (when 'user' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 129,
                    "column": 10,
                    "event": "note",
                    "message": "(29) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 129,
                    "column": 10,
                    "event": "note",
                    "message": "(30) following 'true' branch (when 'group' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 167,
                    "column": 10,
                    "event": "note",
                    "message": "(32) returning to 'describe_change' from 'user_group_str'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 168,
                    "column": 14,
                    "event": "note",
                    "message": "(33) calling 'user_group_str' from 'describe_change'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 123,
                    "column": 1,
                    "event": "note",
                    "message": "(34) entry to 'user_group_str'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 127,
                    "column": 6,
                    "event": "note",
                    "message": "(35) following 'true' branch (when 'user' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 129,
                    "column": 10,
                    "event": "note",
                    "message": "(36) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 129,
                    "column": 10,
                    "event": "note",
                    "message": "(37) following 'false' branch (when 'group' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 136,
                    "column": 18,
                    "event": "note",
                    "message": "(38) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 136,
                    "column": 18,
                    "event": "note",
                    "message": "(39) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 168,
                    "column": 14,
                    "event": "note",
                    "message": "(40) returning to 'describe_change' from 'user_group_str'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 171,
                    "column": 3,
                    "event": "note",
                    "message": "(41) following 'case 3:' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 178,
                    "column": 5,
                    "event": "note",
                    "message": "(42) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chown-core.c",
                    "line": 179,
                    "column": 10,
                    "event": "note",
                    "message": "(43) 'user_group_str(<unknown>,  <unknown>)' leaks here; was allocated at (39)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  177|         break;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  178|       case CH_FAILED:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  179|->       if (old_spec)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  180|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  181|             fmt = (user ? _(\"failed to change ownership of %s from %s to %s\\n\")",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'parse_additional_groups'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 147,
                    "column": 22,
                    "event": "warning[-Wanalyzer-null-dereference]",
                    "message": "dereference of NULL 'gids'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 219,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 232,
                    "column": 16,
                    "event": "note",
                    "message": "(2) 'out_gids' is NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 244,
                    "column": 66,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'c != -1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 246,
                    "column": 7,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 244,
                    "column": 66,
                    "event": "note",
                    "message": "(5) following 'false' branch (when 'c == -1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 277,
                    "column": 12,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 277,
                    "column": 6,
                    "event": "note",
                    "message": "(7) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 283,
                    "column": 29,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 286,
                    "column": 6,
                    "event": "note",
                    "message": "(9) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 293,
                    "column": 6,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 293,
                    "column": 6,
                    "event": "note",
                    "message": "(11) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 301,
                    "column": 10,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 301,
                    "column": 10,
                    "event": "note",
                    "message": "(13) following 'false' branch (when 'userspec' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 46,
                    "column": 22,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 306,
                    "column": 11,
                    "event": "note",
                    "message": "in expansion of macro 'uid_set'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 306,
                    "column": 10,
                    "event": "note",
                    "message": "(15) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 317,
                    "column": 10,
                    "event": "note",
                    "message": "(17) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 28,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 318,
                    "column": 23,
                    "event": "note",
                    "message": "(18) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/ignore-value.h",
                    "line": 46,
                    "column": 45,
                    "event": "note",
                    "message": "in definition of macro 'ignore_value'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 318,
                    "column": 23,
                    "event": "note",
                    "message": "(19) calling 'parse_additional_groups' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/ignore-value.h",
                    "line": 46,
                    "column": 45,
                    "event": "note",
                    "message": "in definition of macro 'ignore_value'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 95,
                    "column": 1,
                    "event": "note",
                    "message": "(20) entry to 'parse_additional_groups'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 105,
                    "column": 14,
                    "event": "note",
                    "message": "(21) when 'strtok' on non-NULL string returns non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 105,
                    "column": 36,
                    "event": "note",
                    "message": "(22) following 'true' branch (when 'tmp' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 110,
                    "column": 11,
                    "event": "note",
                    "message": "(23) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 128,
                    "column": 14,
                    "event": "note",
                    "message": "(24) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 129,
                    "column": 22,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 145,
                    "column": 10,
                    "event": "note",
                    "message": "(26) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 147,
                    "column": 22,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 147,
                    "column": 11,
                    "event": "note",
                    "message": "(28) 'gids' is NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/chroot.c",
                    "line": 147,
                    "column": 22,
                    "event": "note",
                    "message": "(29) dereference of NULL 'gids + n_gids * 4'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  145|         if (n_gids == n_gids_allocated)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  146|           gids = X2NREALLOC (gids, &n_gids_allocated);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  147|->       gids[n_gids++] = value;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  148|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  149|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/copy.c",
                    "line": 0,
                    "event": "internal warning",
                    "message": "child 25355 timed out after 30s",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/cp-hash.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'remember_copied'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/cp-hash.c",
                    "line": 126,
                    "column": 6,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc(24)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/cp-hash.c",
                    "line": 120,
                    "column": 9,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp-hash.c",
                    "line": 126,
                    "column": 6,
                    "event": "note",
                    "message": "(2) 'xmalloc(24)' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  124|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  125|     ent_from_table = hash_insert (src_to_dest, ent);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  126|->   if (ent_from_table == nullptr)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  127|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  128|         /* Insertion failed due to lack of memory.  */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/cp-hash.c",
                    "line": 135,
                    "column": 6,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc(24)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/cp-hash.c",
                    "line": 120,
                    "column": 9,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp-hash.c",
                    "line": 126,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp-hash.c",
                    "line": 135,
                    "column": 6,
                    "event": "note",
                    "message": "(3) ...to here (4) 'xmalloc(24)' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  133|        with a matching key.  If so, free ENT (it wasn't inserted) and",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  134|        return the 'name' from the table entry.  */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  135|->   if (ent_from_table != ent)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  136|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  137|         src_to_dest_free (ent);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 767,
                    "column": 23,
                    "event": "warning[core.CallAndMessage]",
                    "message": "5th function call argument is an uninitialized value",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 621,
                    "column": 18,
                    "event": "note",
                    "message": "Assuming 'target_directory' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 621,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 621,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 633,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'no_target_directory' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 633,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 645,
                    "column": 12,
                    "event": "note",
                    "message": "'target_directory' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 645,
                    "column": 8,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 648,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 685,
                    "column": 7,
                    "event": "note",
                    "message": "'target_directory' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 685,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 694,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'n_files' is < 2",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 694,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 700,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 704,
                    "column": 11,
                    "event": "note",
                    "message": "'attr_list' declared without an initial value",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 710,
                    "column": 15,
                    "event": "note",
                    "message": "Assuming 'remove_trailing_slashes' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 710,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 713,
                    "column": 15,
                    "event": "note",
                    "message": "Assuming 'parents_option' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 713,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 742,
                    "column": 15,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 437,
                    "column": 3,
                    "event": "note",
                    "message": "expanded from macro 'ASSIGN_STRDUPA'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 745,
                    "column": 27,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 750,
                    "column": 16,
                    "event": "note",
                    "message": "'parent_exists' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 750,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 759,
                    "column": 22,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 759,
                    "column": 15,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 762",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 766,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'parents_option' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 766,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/cp.c",
                    "line": 767,
                    "column": 23,
                    "event": "note",
                    "message": "5th function call argument is an uninitialized value",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  765|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  766|                 if (parents_option)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  767|->                 ok &= re_protect (dst_name, arg_in_concat, target_dirfd,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  768|                                     dst_relname, attr_list, x);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  769|               }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'get_new_buffer'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 418,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'get_new_buffer(bytes_wanted)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1296,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1358,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1367,
                    "column": 22,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1373,
                    "column": 6,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1375,
                    "column": 20,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1408,
                    "column": 19,
                    "event": "note",
                    "message": "(6) following 'true' branch (when 'i != 11')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1410,
                    "column": 23,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1419,
                    "column": 19,
                    "event": "note",
                    "message": "(8) following 'true' branch (when 'i != 11')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1420,
                    "column": 44,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1419,
                    "column": 19,
                    "event": "note",
                    "message": "(10) following 'true' branch (when 'i != 11')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1420,
                    "column": 44,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1424,
                    "column": 3,
                    "event": "note",
                    "message": "(12) calling 'split_file' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 855,
                    "column": 1,
                    "event": "note",
                    "message": "(13) entry to 'split_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 857,
                    "column": 23,
                    "event": "note",
                    "message": "(14) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 860,
                    "column": 19,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 860,
                    "column": 10,
                    "event": "note",
                    "message": "(16) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 863,
                    "column": 24,
                    "event": "note",
                    "message": "(18) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 864,
                    "column": 13,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 864,
                    "column": 13,
                    "event": "note",
                    "message": "(20) calling 'process_regexp' from 'split_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 749,
                    "column": 1,
                    "event": "note",
                    "message": "(21) entry to 'process_regexp'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 763,
                    "column": 6,
                    "event": "note",
                    "message": "(22) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(23) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 767,
                    "column": 18,
                    "event": "note",
                    "message": "(24) calling 'find_line' from 'process_regexp'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 564,
                    "column": 1,
                    "event": "note",
                    "message": "(25) entry to 'find_line'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 568,
                    "column": 6,
                    "event": "note",
                    "message": "(26) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 568,
                    "column": 27,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 568,
                    "column": 27,
                    "event": "note",
                    "message": "(28) calling 'load_buffer' from 'find_line'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 456,
                    "column": 1,
                    "event": "note",
                    "message": "(29) entry to 'load_buffer'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 458,
                    "column": 6,
                    "event": "note",
                    "message": "(30) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 29,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 27,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 464,
                    "column": 24,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 468,
                    "column": 33,
                    "event": "note",
                    "message": "(32) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 468,
                    "column": 33,
                    "event": "note",
                    "message": "(33) calling 'get_new_buffer' from 'load_buffer'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 406,
                    "column": 1,
                    "event": "note",
                    "message": "(34) entry to 'get_new_buffer'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 418,
                    "column": 10,
                    "event": "note",
                    "message": "(35) 'get_new_buffer(bytes_wanted)' leaks here; was allocated at (32)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  416|     new_buffer->next = nullptr;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  417|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  418|->   return new_buffer;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  419|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  420|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 576,
                    "column": 21,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'start_line' results in a dereference of a null pointer (loaded from variable 'b')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 857,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming 'i' is < 'control_used'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 857,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 860,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming field 'regexpr' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 860,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 862,
                    "column": 24,
                    "event": "note",
                    "message": "Assuming field 'repeat_forever' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 862,
                    "column": 24,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 863,
                    "column": 27,
                    "event": "note",
                    "message": "Assuming 'j' is <= field 'repeat'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 862,
                    "column": 11,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 864,
                    "column": 13,
                    "event": "note",
                    "message": "Calling 'process_regexp'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 757,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'ignore' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 757,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 763,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'offset' is < 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 763,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 805,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 807,
                    "column": 18,
                    "event": "note",
                    "message": "Calling 'find_line'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 568,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'head' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 568,
                    "column": 23,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 571,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'linenum' is >= field 'start_line'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 571,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 574,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 576,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 576,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 592,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming field 'next' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 592,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 592,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 594,
                    "column": 7,
                    "event": "note",
                    "message": "Null pointer value stored to 'b'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 574,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 576,
                    "column": 21,
                    "event": "note",
                    "message": "Access to field 'start_line' results in a dereference of a null pointer (loaded from variable 'b')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  574|     for (b = head;;)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  575|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  576|->       if (linenum < b->start_line + b->num_lines)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  577|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  578|             /* The line is in this buffer. */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1367,
                    "column": 22,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1316,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1316,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1318,
                    "column": 5,
                    "event": "note",
                    "message": "Control jumps to 'case 110:'  at line 1332",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1333,
                    "column": 41,
                    "event": "note",
                    "message": "2147483647 is < 9223372036854775807",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/sys/param.h",
                    "line": 102,
                    "column": 20,
                    "event": "note",
                    "message": "expanded from macro 'MIN'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1333,
                    "column": 41,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/sys/param.h",
                    "line": 102,
                    "column": 19,
                    "event": "note",
                    "message": "expanded from macro 'MIN'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1333,
                    "column": 18,
                    "event": "note",
                    "message": "Null pointer value stored to 'prefix'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1335,
                    "column": 9,
                    "event": "note",
                    "message": " Execution continues on line 1316",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1316,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1316,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1358",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1358,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1358,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1367,
                    "column": 22,
                    "event": "note",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1365|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1366|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1367|->   idx_t prefix_len = strlen (prefix);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1368|     idx_t max_digit_string_len",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1369|       = (suffix",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'main'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1377,
                    "column": 30,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'ximalloc(__real__ <unknown>)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1358,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1367,
                    "column": 22,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1373,
                    "column": 6,
                    "event": "note",
                    "message": "(3) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1375,
                    "column": 20,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1375,
                    "column": 20,
                    "event": "note",
                    "message": "(5) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/csplit.c",
                    "line": 1377,
                    "column": 30,
                    "event": "note",
                    "message": "(6) 'ximalloc(__real__ <unknown>)' leaks here; was allocated at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1375|     filename_space = ximalloc (filename_size);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1376|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1377|->   set_input_file (argv[optind++]);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1378|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1379|     parse_patterns (argc, optind, argv);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'main'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 316,
                    "column": 32,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'adjust_resolution(format)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 397,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 510,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch (when 'option_specified_date <= 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 517,
                    "column": 16,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 517,
                    "column": 6,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 524,
                    "column": 6,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 524,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch (when 'discarded_datestr == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 527,
                    "column": 6,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 527,
                    "column": 6,
                    "event": "note",
                    "message": "(8) following 'false' branch (when 'discarded_set_datestr == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 530,
                    "column": 14,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 555,
                    "column": 6,
                    "event": "note",
                    "message": "(10) following 'true' branch (when 'format' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 557,
                    "column": 10,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 575,
                    "column": 23,
                    "event": "note",
                    "message": "(12) calling 'adjust_resolution' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 312,
                    "column": 1,
                    "event": "note",
                    "message": "(13) entry to 'adjust_resolution'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 316,
                    "column": 32,
                    "event": "note",
                    "message": "(14) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 317,
                    "column": 8,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 321,
                    "column": 16,
                    "event": "note",
                    "message": "(16) following 'true' branch (when 'copy' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 322,
                    "column": 22,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 322,
                    "column": 22,
                    "event": "note",
                    "message": "(18) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 575,
                    "column": 23,
                    "event": "note",
                    "message": "(19) returning to 'main' from 'adjust_resolution'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 316,
                    "column": 32,
                    "event": "note",
                    "message": "(20) 'adjust_resolution(format)' leaks here; was allocated at (18)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  314|     char *copy = nullptr;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  315|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  316|->   for (char const *f = format; *f; f++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  317|       if (f[0] == '%')",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  318|         {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'batch_convert'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 393,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of '<unknown>'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 397,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 422,
                    "column": 10,
                    "event": "note",
                    "message": "(2) following 'true' branch (when 'optc != -1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 426,
                    "column": 7,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 426,
                    "column": 7,
                    "event": "note",
                    "message": "(4) following 'case 102:' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 436,
                    "column": 9,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 422,
                    "column": 10,
                    "event": "note",
                    "message": "(6) following 'false' branch (when 'optc == -1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 507,
                    "column": 32,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 510,
                    "column": 6,
                    "event": "note",
                    "message": "(8) following 'false' branch (when 'option_specified_date <= 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 517,
                    "column": 16,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 517,
                    "column": 6,
                    "event": "note",
                    "message": "(10) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 524,
                    "column": 6,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 524,
                    "column": 6,
                    "event": "note",
                    "message": "(12) following 'false' branch (when 'discarded_datestr == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 527,
                    "column": 6,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 527,
                    "column": 6,
                    "event": "note",
                    "message": "(14) following 'false' branch (when 'discarded_set_datestr == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 530,
                    "column": 14,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 555,
                    "column": 6,
                    "event": "note",
                    "message": "(16) following 'true' branch (when 'format' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 557,
                    "column": 10,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 557,
                    "column": 10,
                    "event": "note",
                    "message": "(18) following 'false' branch (when 'get_resolution == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 118,
                    "column": 30,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 561,
                    "column": 20,
                    "event": "note",
                    "message": "in expansion of macro 'DATE_FMT_LANGINFO'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 575,
                    "column": 23,
                    "event": "note",
                    "message": "(20) calling 'adjust_resolution' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 312,
                    "column": 1,
                    "event": "note",
                    "message": "(21) entry to 'adjust_resolution'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 316,
                    "column": 32,
                    "event": "note",
                    "message": "(22) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 317,
                    "column": 8,
                    "event": "note",
                    "message": "(23) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 321,
                    "column": 16,
                    "event": "note",
                    "message": "(24) following 'true' branch (when 'copy' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 322,
                    "column": 22,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 322,
                    "column": 22,
                    "event": "note",
                    "message": "(26) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 575,
                    "column": 23,
                    "event": "note",
                    "message": "(27) returning to 'main' from 'adjust_resolution'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 576,
                    "column": 54,
                    "event": "note",
                    "message": "(28) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 577,
                    "column": 26,
                    "event": "note",
                    "message": "(29) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 580,
                    "column": 6,
                    "event": "note",
                    "message": "(30) following 'true' branch (when 'batch_file' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 581,
                    "column": 10,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 581,
                    "column": 10,
                    "event": "note",
                    "message": "(32) calling 'batch_convert' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 339,
                    "column": 1,
                    "event": "note",
                    "message": "(33) entry to 'batch_convert'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 368,
                    "column": 14,
                    "event": "note",
                    "message": "(34) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 20,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 388,
                    "column": 7,
                    "event": "note",
                    "message": "(35) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 388,
                    "column": 6,
                    "event": "note",
                    "message": "(36) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 391,
                    "column": 3,
                    "event": "note",
                    "message": "(37) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 393,
                    "column": 10,
                    "event": "note",
                    "message": "(38) '<unknown>' leaks here; was allocated at (26)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  391|     free (line);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  392|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  393|->   return ok;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  394|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  395|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'main'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 632,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of '<unknown>'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 397,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 510,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch (when 'option_specified_date <= 1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 517,
                    "column": 16,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 517,
                    "column": 6,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 524,
                    "column": 6,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 524,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch (when 'discarded_datestr == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 527,
                    "column": 6,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 527,
                    "column": 6,
                    "event": "note",
                    "message": "(8) following 'false' branch (when 'discarded_set_datestr == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 530,
                    "column": 14,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 555,
                    "column": 6,
                    "event": "note",
                    "message": "(10) following 'true' branch (when 'format' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 557,
                    "column": 10,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 575,
                    "column": 23,
                    "event": "note",
                    "message": "(12) calling 'adjust_resolution' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 312,
                    "column": 1,
                    "event": "note",
                    "message": "(13) entry to 'adjust_resolution'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 316,
                    "column": 32,
                    "event": "note",
                    "message": "(14) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 317,
                    "column": 8,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 321,
                    "column": 16,
                    "event": "note",
                    "message": "(16) following 'true' branch (when 'copy' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 322,
                    "column": 22,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 322,
                    "column": 22,
                    "event": "note",
                    "message": "(18) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 575,
                    "column": 23,
                    "event": "note",
                    "message": "(19) returning to 'main' from 'adjust_resolution'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 576,
                    "column": 54,
                    "event": "note",
                    "message": "(20) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 577,
                    "column": 26,
                    "event": "note",
                    "message": "(21) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 580,
                    "column": 6,
                    "event": "note",
                    "message": "(22) following 'false' branch (when 'batch_file' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 587,
                    "column": 11,
                    "event": "note",
                    "message": "(23) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 587,
                    "column": 10,
                    "event": "note",
                    "message": "(24) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 589,
                    "column": 22,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 589,
                    "column": 14,
                    "event": "note",
                    "message": "(26) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 594,
                    "column": 29,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/date.c",
                    "line": 632,
                    "column": 10,
                    "event": "note",
                    "message": "(28) '<unknown>' leaks here; was allocated at (18)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  630|           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  631|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  632|->       if (! valid_date)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  633|           error (EXIT_FAILURE, 0, _(\"invalid date %s\"), quote (datestr));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  634|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/dd.c",
                    "line": 2510,
                    "column": 19,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'exit_status' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/dd.c",
                    "line": 2510,
                    "column": 19,
                    "event": "note",
                    "message": "Value stored to 'exit_status' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2508|                   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2509|                     diagnose (errno, _(\"cannot fstat %s\"), quoteaf (output_file));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2510|->                   exit_status = EXIT_FAILURE;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2511|                   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2512|                 else if (S_ISREG (stdout_stat.st_mode)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/dd.c",
                    "line": 2521,
                    "column": 19,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'exit_status' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/dd.c",
                    "line": 2521,
                    "column": 19,
                    "event": "note",
                    "message": "Value stored to 'exit_status' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2519|                                 \" in output file %s\"),",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2520|                               isize, quoteaf (output_file));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2521|->                   exit_status = EXIT_FAILURE;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2522|                   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2523|               }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1170,
                    "column": 47,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'total' results in a dereference of a null pointer (loaded from variable 'v')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1027,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'me_remote' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1027,
                    "column": 17,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1030,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'me_dummy' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1030,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 36,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1038,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'force_fsu' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1038,
                    "column": 18,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1045,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'stat_file' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1045,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1049,
                    "column": 7,
                    "event": "note",
                    "message": "'force_fsu' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1049,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1094,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'fsu_blocks' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1094,
                    "column": 27,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1097,
                    "column": 9,
                    "event": "note",
                    "message": "'force_fsu' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1097,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1102,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'device' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1102,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1105,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'file' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1105,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1117,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'process_all' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1118,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'fstype' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1125,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1133,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'print_grand_total' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1133,
                    "column": 25,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1137,
                    "column": 17,
                    "event": "note",
                    "message": "Assuming 'col' is < 'ncolumns'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1137,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1143,
                    "column": 7,
                    "event": "note",
                    "message": "Control jumps to 'case OTHER_FLD:'  at line 1151",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1152,
                    "column": 11,
                    "event": "note",
                    "message": "Null pointer value stored to 'v'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1153,
                    "column": 11,
                    "event": "note",
                    "message": " Execution continues on line 1158",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1158,
                    "column": 7,
                    "event": "note",
                    "message": "Control jumps to 'case ITOTAL_FIELD:'  at line 1169",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1170,
                    "column": 47,
                    "event": "note",
                    "message": "Access to field 'total' results in a dereference of a null pointer (loaded from variable 'v')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1168|           case SIZE_FIELD:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1169|           case ITOTAL_FIELD:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1170|->           cell = xstrdup (df_readable (false, v->total, buf,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1171|                                          v->input_units, v->output_units));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1172|             break;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1176,
                    "column": 40,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'negate_used' results in a dereference of a null pointer (loaded from variable 'v')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1027,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'me_remote' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1027,
                    "column": 17,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1030,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'me_dummy' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1030,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 36,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1038,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'force_fsu' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1038,
                    "column": 18,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1045,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'stat_file' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1045,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1049,
                    "column": 7,
                    "event": "note",
                    "message": "'force_fsu' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1049,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1094,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'fsu_blocks' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1094,
                    "column": 27,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1097,
                    "column": 9,
                    "event": "note",
                    "message": "'force_fsu' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1097,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1102,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'device' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1102,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1105,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'file' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1105,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1117,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'process_all' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1118,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'fstype' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1125,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1133,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'print_grand_total' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1133,
                    "column": 25,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1137,
                    "column": 17,
                    "event": "note",
                    "message": "Assuming 'col' is < 'ncolumns'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1137,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1143,
                    "column": 7,
                    "event": "note",
                    "message": "Control jumps to 'case OTHER_FLD:'  at line 1151",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1152,
                    "column": 11,
                    "event": "note",
                    "message": "Null pointer value stored to 'v'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1153,
                    "column": 11,
                    "event": "note",
                    "message": " Execution continues on line 1158",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1158,
                    "column": 7,
                    "event": "note",
                    "message": "Control jumps to 'case IUSED_FIELD:'  at line 1175",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1176,
                    "column": 40,
                    "event": "note",
                    "message": "Access to field 'negate_used' results in a dereference of a null pointer (loaded from variable 'v')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1174|           case USED_FIELD:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1175|           case IUSED_FIELD:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1176|->           cell = xstrdup (df_readable (v->negate_used, v->used, buf,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1177|                                          v->input_units, v->output_units));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1178|             break;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1182,
                    "column": 40,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'negate_available' results in a dereference of a null pointer (loaded from variable 'v')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1027,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'me_remote' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1027,
                    "column": 17,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1030,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'me_dummy' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1030,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 36,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1038,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'force_fsu' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1038,
                    "column": 18,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1045,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'stat_file' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1045,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1049,
                    "column": 7,
                    "event": "note",
                    "message": "'force_fsu' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1049,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1094,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'fsu_blocks' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1094,
                    "column": 27,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1097,
                    "column": 9,
                    "event": "note",
                    "message": "'force_fsu' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1097,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1102,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'device' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1102,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1105,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'file' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1105,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1117,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'process_all' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1118,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'fstype' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1125,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1133,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'print_grand_total' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1133,
                    "column": 25,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1137,
                    "column": 17,
                    "event": "note",
                    "message": "Assuming 'col' is < 'ncolumns'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1137,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1143,
                    "column": 7,
                    "event": "note",
                    "message": "Control jumps to 'case OTHER_FLD:'  at line 1151",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1152,
                    "column": 11,
                    "event": "note",
                    "message": "Null pointer value stored to 'v'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1153,
                    "column": 11,
                    "event": "note",
                    "message": " Execution continues on line 1158",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1158,
                    "column": 7,
                    "event": "note",
                    "message": "Control jumps to 'case IAVAIL_FIELD:'  at line 1181",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1182,
                    "column": 40,
                    "event": "note",
                    "message": "Access to field 'negate_available' results in a dereference of a null pointer (loaded from variable 'v')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1180|           case AVAIL_FIELD:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1181|           case IAVAIL_FIELD:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1182|->           cell = xstrdup (df_readable (v->negate_available, v->available, buf,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1183|                                          v->input_units, v->output_units));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1184|             break;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1190,
                    "column": 32,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'used' results in a dereference of a null pointer (loaded from variable 'v')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1027,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'me_remote' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1027,
                    "column": 17,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1030,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'me_dummy' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1030,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 36,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1033,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1038,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'force_fsu' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1038,
                    "column": 18,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1045,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'stat_file' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1045,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1049,
                    "column": 7,
                    "event": "note",
                    "message": "'force_fsu' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1049,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1094,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming field 'fsu_blocks' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1094,
                    "column": 27,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1097,
                    "column": 9,
                    "event": "note",
                    "message": "'force_fsu' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1097,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1102,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'device' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1102,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1105,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'file' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1105,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1117,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'process_all' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1118,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'fstype' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1125,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1133,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'print_grand_total' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1133,
                    "column": 25,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1137,
                    "column": 17,
                    "event": "note",
                    "message": "Assuming 'col' is < 'ncolumns'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1137,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1143,
                    "column": 7,
                    "event": "note",
                    "message": "Control jumps to 'case OTHER_FLD:'  at line 1151",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1152,
                    "column": 11,
                    "event": "note",
                    "message": "Null pointer value stored to 'v'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1153,
                    "column": 11,
                    "event": "note",
                    "message": " Execution continues on line 1158",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1158,
                    "column": 7,
                    "event": "note",
                    "message": "Control jumps to 'case IPCENT_FIELD:'  at line 1187",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1190,
                    "column": 32,
                    "event": "note",
                    "message": "Access to field 'used' results in a dereference of a null pointer (loaded from variable 'v')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1188|             {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1189|               double pct = -1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1190|->             if (! known_value (v->used) || ! known_value (v->available))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1191|                 ;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1192|               else if (!v->negate_used",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1624,
                    "column": 15,
                    "event": "warning[core.CallAndMessage]",
                    "message": "8th function call argument is an uninitialized value",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 134,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'DIGEST_OUT'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1380,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1380,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1469",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1476,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1476,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1481,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1481,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1489,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'digest_length' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1489,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1523,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1526,
                    "column": 7,
                    "event": "note",
                    "message": "'prefix_tag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1526,
                    "column": 18,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1541,
                    "column": 28,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1548,
                    "column": 7,
                    "event": "note",
                    "message": "'prefix_tag' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1548,
                    "column": 18,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1556,
                    "column": 12,
                    "event": "note",
                    "message": "'binary' is < 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1556,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1563,
                    "column": 7,
                    "event": "note",
                    "message": "'ignore_missing' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1563,
                    "column": 22,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1571,
                    "column": 7,
                    "event": "note",
                    "message": "'status_only' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1571,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1578,
                    "column": 7,
                    "event": "note",
                    "message": "'warn' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1578,
                    "column": 12,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1585,
                    "column": 7,
                    "event": "note",
                    "message": "'quiet' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1585,
                    "column": 13,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1592,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1599,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1599,
                    "column": 20,
                    "event": "note",
                    "message": "'binary' is < 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1599,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1603,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'optind' is not equal to 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1603,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1605,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1605,
                    "column": 30,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1609,
                    "column": 41,
                    "event": "note",
                    "message": "Assuming 'operandp' is < 'operand_lim'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1609,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1612,
                    "column": 11,
                    "event": "note",
                    "message": "'do_check' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1612,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1618,
                    "column": 11,
                    "event": "note",
                    "message": "'length' declared without an initial value",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1620,
                    "column": 17,
                    "event": "note",
                    "message": "Calling 'digest_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 978,
                    "column": 7,
                    "event": "note",
                    "message": "'is_stdin' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 978,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 982,
                    "column": 20,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1018,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'err' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1018,
                    "column": 9,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1019,
                    "column": 7,
                    "event": "note",
                    "message": "'is_stdin' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1019,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1024,
                    "column": 7,
                    "event": "note",
                    "message": "'err' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1024,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1030,
                    "column": 3,
                    "event": "note",
                    "message": "Returning without writing to '*length'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1620,
                    "column": 17,
                    "event": "note",
                    "message": "Returning from 'digest_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1620,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1625,
                    "column": 41,
                    "event": "note",
                    "message": "Assuming 'optind' is equal to 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 1624,
                    "column": 15,
                    "event": "note",
                    "message": "8th function call argument is an uninitialized value",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/digest.c",
                    "line": 134,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'DIGEST_OUT'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1622|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1623|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1624|->               DIGEST_OUT (file, binary_file, bin_buffer, raw_digest, prefix_tag,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1625|                             digest_delim, optind != argc, length);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1626|               }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'parse_signal_action_params.part.0'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 567,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xstrdup(arg)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 558,
                    "column": 21,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 560,
                    "column": 13,
                    "event": "note",
                    "message": "(2) when 'strtok' with NULL string (using prior) returns non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 561,
                    "column": 10,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'opt_sig' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 563,
                    "column": 20,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 567,
                    "column": 10,
                    "event": "note",
                    "message": "(5) 'xstrdup(arg)' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  565|         if (signum == 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  566|           error (0, 0, _(\"%s: invalid signal\"), quote (opt_sig));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  567|->       if (signum <= 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  568|           usage (exit_failure);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  569|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 570,
                    "column": 14,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xstrdup(arg)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 558,
                    "column": 21,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 560,
                    "column": 13,
                    "event": "note",
                    "message": "(2) when 'strtok' with NULL string (using prior) returns non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 561,
                    "column": 10,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'opt_sig' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 563,
                    "column": 20,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 567,
                    "column": 10,
                    "event": "note",
                    "message": "(5) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 570,
                    "column": 47,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 572,
                    "column": 17,
                    "event": "note",
                    "message": "(7) when 'strtok' with NULL string (using prior) returns non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 561,
                    "column": 10,
                    "event": "note",
                    "message": "(8) following 'true' branch (when 'opt_sig' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 563,
                    "column": 20,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 570,
                    "column": 14,
                    "event": "note",
                    "message": "(10) 'xstrdup(arg)' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  568|           usage (exit_failure);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  569|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  570|->       signals[signum] = set_default ? DEFAULT : IGNORE;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  571|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  572|         opt_sig = strtok (nullptr, \",\");",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'parse_block_signal_params.part.0'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 656,
                    "column": 10,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xstrdup(arg)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 647,
                    "column": 21,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 649,
                    "column": 13,
                    "event": "note",
                    "message": "(2) when 'strtok' with NULL string (using prior) returns non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 650,
                    "column": 10,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'opt_sig' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 652,
                    "column": 20,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 656,
                    "column": 10,
                    "event": "note",
                    "message": "(5) 'xstrdup(arg)' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  654|         if (signum == 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  655|           error (0, 0, _(\"%s: invalid signal\"), quote (opt_sig));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  656|->       if (signum <= 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  657|           usage (exit_failure);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  658|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 661,
                    "column": 14,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xstrdup(arg)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 647,
                    "column": 21,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 649,
                    "column": 13,
                    "event": "note",
                    "message": "(2) when 'strtok' with NULL string (using prior) returns non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 650,
                    "column": 10,
                    "event": "note",
                    "message": "(3) following 'true' branch (when 'opt_sig' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 652,
                    "column": 20,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 656,
                    "column": 10,
                    "event": "note",
                    "message": "(5) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 659,
                    "column": 11,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/env.c",
                    "line": 661,
                    "column": 14,
                    "event": "note",
                    "message": "(7) 'xstrdup(arg)' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  659|         if (sigaddset (block ? &block_signals : &unblock_signals, signum) == -1)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  660|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  661|->           if (block)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  662|               error (EXIT_CANCELED, errno,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  663|                      _(\"failed to block signal %d\"), signum);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/expand-common.c",
                    "line": 455,
                    "column": 11,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/expand-common.c",
                    "line": 447,
                    "column": 3,
                    "event": "note",
                    "message": "'prev_file' initialized to a null pointer value",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/expand-common.c",
                    "line": 450,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'fp' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/expand-common.c",
                    "line": 450,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/expand-common.c",
                    "line": 453,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/expand-common.c",
                    "line": 455,
                    "column": 11,
                    "event": "note",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  453|         if (!ferror (fp))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  454|           err = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  455|->       if (STREQ (prev_file, \"-\"))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  456|           clearerr (fp);\t\t/* Also clear EOF.  */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  457|         else if (fclose (fp) != 0)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 457,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/factor.c",
                    "line": 1392,
                    "event": "error[uninitvar]",
                    "message": "Uninitialized variable: q",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1390|       return true;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1391|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1392|->   mpz_inits (q, a, nm1, tmp, nullptr);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1393|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1394|     /* Precomputation for Miller-Rabin.  */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 457,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/factor.c",
                    "line": 1679,
                    "event": "error[uninitvar]",
                    "message": "Uninitialized variable: t",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1677|     devmsg (\"[pollard-rho (%lu)] \", a);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1678|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1679|->   mpz_inits (t, t2, nullptr);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1680|     mpz_init_set_si (y, 2);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1681|     mpz_init_set_si (x, 2);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/head.c",
                    "line": 382,
                    "event": "warning[nullPointer]",
                    "message": "Possible null pointer dereference: b",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  380|             if (! buffered_enough)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  381|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  382|->               b[i] = xmalloc (READ_BUFSIZE);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  383|                 n_alloc = i + 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  384|               }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 476,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/head.c",
                    "line": 385,
                    "event": "warning[nullPointer]",
                    "message": "Possible null pointer dereference: b",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  383|                 n_alloc = i + 1;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  384|               }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  385|->           n_read = full_read (fd, b[i], READ_BUFSIZE);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  386|             if (n_read < READ_BUFSIZE)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  387|               {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/hostname.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'single_binary_main_hostname'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/hostname.c",
                    "line": 108,
                    "column": 7,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xgethostname()'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/hostname.c",
                    "line": 89,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/hostname.c",
                    "line": 95,
                    "column": 6,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/hostname.c",
                    "line": 95,
                    "column": 6,
                    "event": "note",
                    "message": "(3) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/hostname.c",
                    "line": 105,
                    "column": 18,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/hostname.c",
                    "line": 105,
                    "column": 18,
                    "event": "note",
                    "message": "(5) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/hostname.c",
                    "line": 106,
                    "column": 10,
                    "event": "note",
                    "message": "(6) assuming 'xgethostname()' is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/hostname.c",
                    "line": 106,
                    "column": 10,
                    "event": "note",
                    "message": "(7) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/hostname.c",
                    "line": 108,
                    "column": 7,
                    "event": "note",
                    "message": "(8) ...to here (9) 'xgethostname()' leaks here; was allocated at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  106|         if (hostname == nullptr)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  107|           error (EXIT_FAILURE, errno, _(\"cannot determine hostname\"));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  108|->       puts (hostname);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  109|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  110|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'apply_mode'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 128,
                    "column": 6,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'buf'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 98,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 100,
                    "column": 11,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 100,
                    "column": 11,
                    "event": "note",
                    "message": "(3) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 106,
                    "column": 14,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 107,
                    "column": 10,
                    "event": "note",
                    "message": "(5) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 114,
                    "column": 46,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 114,
                    "column": 46,
                    "event": "note",
                    "message": "(7) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 115,
                    "column": 10,
                    "event": "note",
                    "message": "(8) assuming 'buf' is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 115,
                    "column": 10,
                    "event": "note",
                    "message": "(9) following 'false' branch (when 'buf' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 128,
                    "column": 6,
                    "event": "note",
                    "message": "(11) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 128,
                    "column": 6,
                    "event": "note",
                    "message": "(13) 'buf' leaks here; was allocated at (7)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  126|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  127|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  128|->   if (setvbuf (stream, buf, setvbuf_mode, size) != 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  129|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  130|         fprintf (stderr, _(\"could not set buffering of %s to mode %s\\n\"),",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 134,
                    "column": 1,
                    "event": "warning[unix.Malloc]",
                    "message": "Potential leak of memory pointed to by 'buf'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 143,
                    "column": 7,
                    "event": "note",
                    "message": "'e_mode' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 143,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 144,
                    "column": 5,
                    "event": "note",
                    "message": "Calling 'apply_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 98,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 98,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 100,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 100,
                    "column": 8,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 107,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'size' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 107,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 107,
                    "column": 24,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 107,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 114,
                    "column": 13,
                    "event": "note",
                    "message": "'size' is <= SIZE_MAX",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 114,
                    "column": 13,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 114,
                    "column": 32,
                    "event": "note",
                    "message": "Memory is allocated",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 115,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'buf' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 115,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 128,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 128,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/libstdbuf.c",
                    "line": 134,
                    "column": 1,
                    "event": "note",
                    "message": "Potential leak of memory pointed to by 'buf'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  132|         free (buf);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  133|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  134|-> }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  135|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  136|   /* Use __attribute to avoid elision of __attribute__ on SUNPRO_C etc.  */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5155,
                    "column": 28,
                    "event": "warning[core.DivideZero]",
                    "message": "Division by zero",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1676,
                    "column": 25,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/intprops.h",
                    "line": 46,
                    "column": 32,
                    "event": "note",
                    "message": "expanded from macro 'TYPE_MINIMUM'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/intprops.h",
                    "line": 48,
                    "column": 9,
                    "event": "note",
                    "message": "expanded from macro 'TYPE_MAXIMUM'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1681,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'print_with_color' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1681,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1687,
                    "column": 7,
                    "event": "note",
                    "message": "'print_with_color' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1687,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1695,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'directories_first' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1695,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1697,
                    "column": 12,
                    "event": "note",
                    "message": "'print_with_color' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1697,
                    "column": 8,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1706,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'dereference' is not equal to DEREF_UNDEFINED",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1706,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1715,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'recursive' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1715,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1729,
                    "column": 23,
                    "event": "note",
                    "message": "Assuming 'sort_type' is not equal to sort_time",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1729,
                    "column": 23,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1729,
                    "column": 49,
                    "event": "note",
                    "message": "Assuming 'sort_type' is equal to sort_size",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1730,
                    "column": 5,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1733,
                    "column": 26,
                    "event": "note",
                    "message": "'format_needs_stat' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1734,
                    "column": 24,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1739,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'dired' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1739,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1745,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'print_hyperlink' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1745,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1764,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'n_files' is > 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1764,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1774,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1772,
                    "column": 5,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1776,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'cwd_n_used' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1776,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1788,
                    "column": 7,
                    "event": "note",
                    "message": "'cwd_n_used' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1788,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1794,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming 'n_files' is > 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1794,
                    "column": 25,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1797,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1802,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'active_dir_set' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 323,
                    "column": 23,
                    "event": "note",
                    "message": "expanded from macro 'LOOP_DETECT'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1802,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1821,
                    "column": 7,
                    "event": "note",
                    "message": "Calling 'print_dir'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 2994,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'dirp' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 2994,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3000,
                    "column": 7,
                    "event": "note",
                    "message": "'active_dir_set' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 323,
                    "column": 24,
                    "event": "note",
                    "message": "expanded from macro 'LOOP_DETECT'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3000,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3032,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'recursive' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3032,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3032,
                    "column": 20,
                    "event": "note",
                    "message": "Assuming 'print_dir_name' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3032,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3058,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3065,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/errno.h",
                    "line": 38,
                    "column": 16,
                    "event": "note",
                    "message": "expanded from macro 'errno'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3065,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3067,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'next' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3067,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3069,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3074,
                    "column": 15,
                    "event": "note",
                    "message": "'Default' branch taken. Execution continues on line 3088",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3096,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'format' is equal to one_per_line",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3096,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3096,
                    "column": 45,
                    "event": "note",
                    "message": "Assuming 'sort_type' is equal to sort_none",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3096,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3097,
                    "column": 26,
                    "event": "note",
                    "message": "Assuming 'print_block_size' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3096,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3097,
                    "column": 47,
                    "event": "note",
                    "message": "Assuming 'recursive' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3096,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3103,
                    "column": 19,
                    "event": "note",
                    "message": "Calling 'print_current_files'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 4139,
                    "column": 3,
                    "event": "note",
                    "message": "Control jumps to 'case many_per_line:'  at line 4149",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 4150,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'line_length' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 4150,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 4153,
                    "column": 9,
                    "event": "note",
                    "message": "Calling 'print_many_per_line'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5150,
                    "column": 17,
                    "event": "note",
                    "message": "Calling 'calculate_columns'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5385,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming 'max_idx' is <= 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5385,
                    "column": 33,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5385,
                    "column": 3,
                    "event": "note",
                    "message": "'max_cols' initialized here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5390,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming 'filesno' is < 'cwd_n_used'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5390,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5395,
                    "column": 26,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'max_cols'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5395,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 5390",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5390,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming 'filesno' is >= 'cwd_n_used'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5390,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 5417",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5417,
                    "column": 8,
                    "event": "note",
                    "message": "The value 0 is assigned to 'cols'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5417,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 5423",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5423,
                    "column": 3,
                    "event": "note",
                    "message": "Returning zero (loaded from 'cols')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5150,
                    "column": 17,
                    "event": "note",
                    "message": "Returning from 'calculate_columns'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5150,
                    "column": 3,
                    "event": "note",
                    "message": "'cols' initialized to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5155,
                    "column": 28,
                    "event": "note",
                    "message": "Division by zero",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5153|     /* Calculate the number of rows that will be in each column except possibly",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5154|        for a short column on the right.  */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5155|->   size_t rows = cwd_n_used / cols + (cwd_n_used % cols != 0);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5156|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5157|     for (row = 0; row < rows; row++)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5199,
                    "column": 28,
                    "event": "warning[core.DivideZero]",
                    "message": "Division by zero",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1676,
                    "column": 25,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/intprops.h",
                    "line": 46,
                    "column": 32,
                    "event": "note",
                    "message": "expanded from macro 'TYPE_MINIMUM'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/intprops.h",
                    "line": 48,
                    "column": 9,
                    "event": "note",
                    "message": "expanded from macro 'TYPE_MAXIMUM'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1681,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'print_with_color' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1681,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1687,
                    "column": 7,
                    "event": "note",
                    "message": "'print_with_color' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1687,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1695,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'directories_first' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1695,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1697,
                    "column": 12,
                    "event": "note",
                    "message": "'print_with_color' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1697,
                    "column": 8,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1706,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'dereference' is not equal to DEREF_UNDEFINED",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1706,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1715,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'recursive' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1715,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1729,
                    "column": 23,
                    "event": "note",
                    "message": "Assuming 'sort_type' is not equal to sort_time",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1729,
                    "column": 23,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1729,
                    "column": 49,
                    "event": "note",
                    "message": "Assuming 'sort_type' is equal to sort_size",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1730,
                    "column": 5,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1733,
                    "column": 26,
                    "event": "note",
                    "message": "'format_needs_stat' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1734,
                    "column": 24,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1739,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'dired' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1739,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1745,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'print_hyperlink' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1745,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1764,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'n_files' is > 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1764,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1774,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1772,
                    "column": 5,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1776,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'cwd_n_used' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1776,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1788,
                    "column": 7,
                    "event": "note",
                    "message": "'cwd_n_used' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1788,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1794,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming 'n_files' is > 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1794,
                    "column": 25,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1797,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1802,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'active_dir_set' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 323,
                    "column": 23,
                    "event": "note",
                    "message": "expanded from macro 'LOOP_DETECT'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1802,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 1821,
                    "column": 7,
                    "event": "note",
                    "message": "Calling 'print_dir'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 2994,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'dirp' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 2994,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3000,
                    "column": 7,
                    "event": "note",
                    "message": "'active_dir_set' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 323,
                    "column": 24,
                    "event": "note",
                    "message": "expanded from macro 'LOOP_DETECT'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3000,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3032,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'recursive' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3032,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3032,
                    "column": 20,
                    "event": "note",
                    "message": "Assuming 'print_dir_name' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3032,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3058,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3065,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/errno.h",
                    "line": 38,
                    "column": 16,
                    "event": "note",
                    "message": "expanded from macro 'errno'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3065,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3067,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'next' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3067,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3069,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3074,
                    "column": 15,
                    "event": "note",
                    "message": "'Default' branch taken. Execution continues on line 3088",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3096,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'format' is equal to one_per_line",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3096,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3096,
                    "column": 45,
                    "event": "note",
                    "message": "Assuming 'sort_type' is equal to sort_none",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3096,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3097,
                    "column": 26,
                    "event": "note",
                    "message": "Assuming 'print_block_size' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3096,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3097,
                    "column": 47,
                    "event": "note",
                    "message": "Assuming 'recursive' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3096,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 3103,
                    "column": 19,
                    "event": "note",
                    "message": "Calling 'print_current_files'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 4139,
                    "column": 3,
                    "event": "note",
                    "message": "Control jumps to 'case horizontal:'  at line 4156",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 4157,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'line_length' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 4157,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 4160,
                    "column": 9,
                    "event": "note",
                    "message": "Calling 'print_horizontal'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5187,
                    "column": 17,
                    "event": "note",
                    "message": "Calling 'calculate_columns'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5385,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming 'max_idx' is <= 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5385,
                    "column": 33,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5385,
                    "column": 3,
                    "event": "note",
                    "message": "'max_cols' initialized here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5390,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming 'filesno' is < 'cwd_n_used'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5390,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5395,
                    "column": 26,
                    "event": "note",
                    "message": "Assuming 'i' is >= 'max_cols'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5395,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 5390",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5390,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming 'filesno' is >= 'cwd_n_used'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5390,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 5417",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5417,
                    "column": 8,
                    "event": "note",
                    "message": "The value 0 is assigned to 'cols'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5417,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 5423",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5423,
                    "column": 3,
                    "event": "note",
                    "message": "Returning zero (loaded from 'cols')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5187,
                    "column": 17,
                    "event": "note",
                    "message": "Returning from 'calculate_columns'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5187,
                    "column": 3,
                    "event": "note",
                    "message": "'cols' initialized to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5197,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming 'filesno' is < 'cwd_n_used'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5197,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5199,
                    "column": 28,
                    "event": "note",
                    "message": "Division by zero",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5197|     for (filesno = 1; filesno < cwd_n_used; ++filesno)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5198|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5199|->       size_t col = filesno % cols;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5200|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5201|         if (col == 0)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'init_column_info'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5359,
                    "column": 25,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of '<unknown>'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5317,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5322,
                    "column": 11,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5347,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5349,
                    "column": 13,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5349,
                    "column": 13,
                    "event": "note",
                    "message": "(5) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5353,
                    "column": 37,
                    "event": "note",
                    "message": "(6) following 'true' branch (when 'i < new_column_info_alloc')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5355,
                    "column": 22,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5353,
                    "column": 37,
                    "event": "note",
                    "message": "(8) following 'false' branch (when 'i >= new_column_info_alloc')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5359,
                    "column": 25,
                    "event": "note",
                    "message": "(9) ...to here (10) '<unknown>' leaks here; was allocated at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5357|           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5358|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5359|->       column_info_alloc = new_column_info_alloc;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5360|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5361|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5371,
                    "column": 1,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'p'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5317,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5322,
                    "column": 11,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5347,
                    "column": 12,
                    "event": "note",
                    "message": "(3) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5349,
                    "column": 13,
                    "event": "note",
                    "message": "(4) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5349,
                    "column": 13,
                    "event": "note",
                    "message": "(5) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5353,
                    "column": 37,
                    "event": "note",
                    "message": "(6) following 'false' branch (when 'i >= new_column_info_alloc')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5359,
                    "column": 25,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ls.c",
                    "line": 5371,
                    "column": 1,
                    "event": "note",
                    "message": "(8) 'p' leaks here; was allocated at (5)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5369|           column_info[i].col_arr[j] = MIN_COLUMN_WIDTH;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5370|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5371|-> }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5372|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 5373|   /* Calculate the number of columns needed to represent the current set",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 395,
                    "column": 11,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 2nd parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 491,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 491,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 577",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 577,
                    "column": 8,
                    "event": "note",
                    "message": "'ok' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 577,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 594,
                    "column": 3,
                    "event": "note",
                    "message": "Null pointer value stored to 'header_del'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 608,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'optind' is equal to 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 608,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 609,
                    "column": 10,
                    "event": "note",
                    "message": "Calling 'nl_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 439,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 443,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'stream' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/verify.h",
                    "line": 357,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'assume'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 443,
                    "column": 7,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/verify.h",
                    "line": 357,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'assume'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 457,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'process_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 411,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 413,
                    "column": 15,
                    "event": "note",
                    "message": "Calling 'check_section'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'len' is >= 2",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 18,
                    "event": "note",
                    "message": "Assuming 'footer_del_len' is >= 2",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 392,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 394,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'len' is equal to 'header_del_len'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 394,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 395,
                    "column": 11,
                    "event": "note",
                    "message": "Null pointer passed to 2nd parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  393|       return Text;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  394|     if (len == header_del_len",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  395|->       && !memcmp (line_buf.buffer, header_del, header_del_len))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  396|       return Header;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  397|     if (len == body_del_len",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 398,
                    "column": 11,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 2nd parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 491,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 491,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 577",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 577,
                    "column": 8,
                    "event": "note",
                    "message": "'ok' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 577,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 594,
                    "column": 3,
                    "event": "note",
                    "message": "Null pointer value stored to 'body_del'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 608,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'optind' is equal to 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 608,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 609,
                    "column": 10,
                    "event": "note",
                    "message": "Calling 'nl_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 439,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 443,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'stream' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/verify.h",
                    "line": 357,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'assume'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 443,
                    "column": 7,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/verify.h",
                    "line": 357,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'assume'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 457,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'process_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 411,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 413,
                    "column": 15,
                    "event": "note",
                    "message": "Calling 'check_section'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'len' is >= 2",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 18,
                    "event": "note",
                    "message": "Assuming 'footer_del_len' is >= 2",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 392,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 394,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'len' is not equal to 'header_del_len'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 395,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 397,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'len' is equal to 'body_del_len'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 397,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 398,
                    "column": 11,
                    "event": "note",
                    "message": "Null pointer passed to 2nd parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  396|       return Header;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  397|     if (len == body_del_len",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  398|->       && !memcmp (line_buf.buffer, body_del, body_del_len))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  399|       return Body;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  400|     if (len == footer_del_len",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 401,
                    "column": 11,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 2nd parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 491,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 491,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 577",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 577,
                    "column": 8,
                    "event": "note",
                    "message": "'ok' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 577,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 594,
                    "column": 3,
                    "event": "note",
                    "message": "Null pointer value stored to 'footer_del'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 608,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'optind' is equal to 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 608,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 609,
                    "column": 10,
                    "event": "note",
                    "message": "Calling 'nl_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 439,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 443,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'stream' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/verify.h",
                    "line": 357,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'assume'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 443,
                    "column": 7,
                    "event": "note",
                    "message": "'?' condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/verify.h",
                    "line": 357,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'assume'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 457,
                    "column": 3,
                    "event": "note",
                    "message": "Calling 'process_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 411,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 413,
                    "column": 15,
                    "event": "note",
                    "message": "Calling 'check_section'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'len' is >= 2",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 18,
                    "event": "note",
                    "message": "Assuming 'footer_del_len' is >= 2",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 392,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 391,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 394,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'len' is not equal to 'header_del_len'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 395,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 397,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'len' is not equal to 'body_del_len'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 398,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 400,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'len' is equal to 'footer_del_len'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 400,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nl.c",
                    "line": 401,
                    "column": 11,
                    "event": "note",
                    "message": "Null pointer passed to 2nd parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  399|       return Body;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  400|     if (len == footer_del_len",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  401|->       && !memcmp (line_buf.buffer, footer_del, footer_del_len))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  402|       return Footer;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  403|     return Text;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'single_binary_main_nohup'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 164,
                    "column": 18,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'in_home'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 111,
                    "column": 6,
                    "event": "note",
                    "message": "(1) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 117,
                    "column": 20,
                    "event": "note",
                    "message": "(2) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 117,
                    "column": 20,
                    "event": "note",
                    "message": "(3) when 'isatty' fails",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 118,
                    "column": 24,
                    "event": "note",
                    "message": "(4) when 'isatty' succeeds",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 119,
                    "column": 43,
                    "event": "note",
                    "message": "(5) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 120,
                    "column": 24,
                    "event": "note",
                    "message": "(7) when 'isatty' fails",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 125,
                    "column": 6,
                    "event": "note",
                    "message": "(8) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 138,
                    "column": 6,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 138,
                    "column": 6,
                    "event": "note",
                    "message": "(10) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 144,
                    "column": 28,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 147,
                    "column": 17,
                    "event": "note",
                    "message": "(12) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 146,
                    "column": 19,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 149,
                    "column": 10,
                    "event": "note",
                    "message": "(14) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 73,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 24,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 151,
                    "column": 29,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 153,
                    "column": 14,
                    "event": "note",
                    "message": "(16) following 'true' branch (when 'home' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 155,
                    "column": 25,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 155,
                    "column": 25,
                    "event": "note",
                    "message": "(18) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 158,
                    "column": 25,
                    "event": "note",
                    "message": "(19) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 157,
                    "column": 27,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 160,
                    "column": 14,
                    "event": "note",
                    "message": "(21) following 'true' branch (when 'out_fd < 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 162,
                    "column": 19,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/nohup.c",
                    "line": 164,
                    "column": 18,
                    "event": "note",
                    "message": "(23) 'in_home' leaks here; was allocated at (18)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  162|                 int saved_errno2 = errno;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  163|                 error (0, saved_errno, _(\"failed to open %s\"), quoteaf (file));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  164|->               if (in_home)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  165|                   error (0, saved_errno2, _(\"failed to open %s\"),",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  166|                          quoteaf (in_home));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 415,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/numfmt.c",
                    "line": 863,
                    "event": "error[doubleFree]",
                    "message": "Memory pointed to by 't_string' is freed twice.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  861|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  862|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  863|->   free (t_string);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  864|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  865|     return n;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'paste_parallel'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 180,
                    "column": 20,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc(nfiles + 2)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 176,
                    "column": 18,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 192,
                    "column": 35,
                    "event": "note",
                    "message": "(2) following 'true' branch (when 'files_open < nfiles')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 43,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 194,
                    "column": 25,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 30,
                    "event": "note",
                    "message": "in definition of macro 'STREQ'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 194,
                    "column": 10,
                    "event": "note",
                    "message": "(4) following 'false' branch (when the strings are non-equal)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 201,
                    "column": 18,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 180,
                    "column": 20,
                    "event": "note",
                    "message": "(6) 'xmalloc(nfiles + 2)' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  178|     /* Streams open to the files to process; null if the corresponding",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  179|        stream is closed.  */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  180|->   FILE **fileptr = xnmalloc (nfiles + 1, sizeof *fileptr);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  181|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  182|     /* Number of files still open to process.  */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 194,
                    "column": 25,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xnmalloc(nfiles + 1, 8)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 30,
                    "event": "note",
                    "message": "in definition of macro 'STREQ'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 180,
                    "column": 20,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 192,
                    "column": 35,
                    "event": "note",
                    "message": "(2) following 'true' branch (when 'files_open < nfiles')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 194,
                    "column": 25,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 30,
                    "event": "note",
                    "message": "in definition of macro 'STREQ'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 194,
                    "column": 10,
                    "event": "note",
                    "message": "(4) following 'false' branch (when the strings are non-equal)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 201,
                    "column": 18,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/paste.c",
                    "line": 194,
                    "column": 25,
                    "event": "note",
                    "message": "(6) 'xnmalloc(nfiles + 1, 8)' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 30,
                    "event": "note",
                    "message": "in definition of macro 'STREQ'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  192|     for (files_open = 0; files_open < nfiles; ++files_open)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  193|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  194|->       if (STREQ (fnamptr[files_open], \"-\"))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  195|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  196|             have_read_stdin = true;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'print_entry'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 312,
                    "column": 1,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'host'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "<command-line>",
                    "line": 0,
                    "event": "note",
                    "message": "(1) entry to 'single_binary_main_pinky'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 529,
                    "column": 1,
                    "event": "note",
                    "message": "in expansion of macro 'main'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 612,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 613,
                    "column": 43,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 613,
                    "column": 5,
                    "event": "note",
                    "message": "(4) calling 'short_pinky' from 'single_binary_main_pinky'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 471,
                    "column": 1,
                    "event": "note",
                    "message": "(5) entry to 'short_pinky'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 476,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 479,
                    "column": 3,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 479,
                    "column": 3,
                    "event": "note",
                    "message": "(8) calling 'scan_entries' from 'short_pinky'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 431,
                    "column": 1,
                    "event": "note",
                    "message": "(9) entry to 'scan_entries'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 448,
                    "column": 10,
                    "event": "note",
                    "message": "(10) following 'true' branch (when 'n != 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 30,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.h",
                    "line": 289,
                    "column": 8,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 450,
                    "column": 11,
                    "event": "note",
                    "message": "in expansion of macro 'IS_USER_PROCESS'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 450,
                    "column": 10,
                    "event": "note",
                    "message": "(12) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 452,
                    "column": 14,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 452,
                    "column": 14,
                    "event": "note",
                    "message": "(14) following 'false' branch (when 'argc_names == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 462,
                    "column": 13,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 462,
                    "column": 13,
                    "event": "note",
                    "message": "(16) calling 'print_entry' from 'scan_entries'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 199,
                    "column": 1,
                    "event": "note",
                    "message": "(17) entry to 'print_entry'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 207,
                    "column": 17,
                    "event": "note",
                    "message": "(18) when 'strchr' returns NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 208,
                    "column": 28,
                    "event": "note",
                    "message": "(19) following 'false' branch (when 'space' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/dirname.h",
                    "line": 29,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 257,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 26,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/filename.h",
                    "line": 97,
                    "column": 61,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/filename.h",
                    "line": 93,
                    "column": 23,
                    "event": "note",
                    "message": "in definition of macro 'ISSLASH'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 211,
                    "column": 7,
                    "event": "note",
                    "message": "in expansion of macro 'IS_ABSOLUTE_FILE_NAME'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 281,
                    "column": 6,
                    "event": "note",
                    "message": "(21) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 288,
                    "column": 17,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 288,
                    "column": 17,
                    "event": "note",
                    "message": "(23) when 'strchr' returns NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 289,
                    "column": 10,
                    "event": "note",
                    "message": "(24) following 'false' branch (when 'display' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 292,
                    "column": 11,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 292,
                    "column": 10,
                    "event": "note",
                    "message": "(26) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 294,
                    "column": 16,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 294,
                    "column": 16,
                    "event": "note",
                    "message": "(28) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 295,
                    "column": 10,
                    "event": "note",
                    "message": "(29) assuming 'canon_host(*utmp_ent.ut_host)' is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 295,
                    "column": 10,
                    "event": "note",
                    "message": "(30) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 254,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 78,
                    "column": 22,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 298,
                    "column": 7,
                    "event": "note",
                    "message": "in expansion of macro 'fputc'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 300,
                    "column": 10,
                    "event": "note",
                    "message": "(32) following 'false' branch (when 'display' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 306,
                    "column": 10,
                    "event": "note",
                    "message": "(33) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 306,
                    "column": 10,
                    "event": "note",
                    "message": "(34) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/unlocked-io.h",
                    "line": 127,
                    "column": 22,
                    "event": "note",
                    "message": "(35) inlined call to 'putchar_unlocked' from 'print_entry'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 311,
                    "column": 3,
                    "event": "note",
                    "message": "in expansion of macro 'putchar'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/bits/stdio.h",
                    "line": 110,
                    "column": 10,
                    "event": "note",
                    "message": "(36) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'print_entry'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/pinky.c",
                    "line": 312,
                    "column": 1,
                    "event": "note",
                    "message": "(37) 'host' leaks here; was allocated at (28)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  310|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  311|     putchar ('\\n');",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  312|-> }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  313|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  314|   /* Display a verbose line of information about UTMP_ENT. */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 985,
                    "column": 35,
                    "event": "warning[core.NullDereference]",
                    "message": "Array access (from variable 'file_names') results in a null pointer dereference",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 942,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/stdlib.h",
                    "line": 97,
                    "column": 20,
                    "event": "note",
                    "message": "expanded from macro 'MB_CUR_MAX'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 942,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 955,
                    "column": 17,
                    "event": "note",
                    "message": "Assuming 'argc' is <= 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 955,
                    "column": 17,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 955,
                    "column": 3,
                    "event": "note",
                    "message": "Null pointer value stored to 'file_names'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 959,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 963,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 963,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 966,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 153,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'ISDIGIT'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 966,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 979,
                    "column": 7,
                    "event": "note",
                    "message": "Control jumps to 'case 1:'  at line 981",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 983,
                    "column": 18,
                    "event": "note",
                    "message": "'first_page_number' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 983,
                    "column": 18,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 984,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 984,
                    "column": 36,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 983,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 985,
                    "column": 35,
                    "event": "note",
                    "message": "Array access (from variable 'file_names') results in a null pointer dereference",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  983|             if (! (first_page_number == 0",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  984|                    && *optarg == '+' && first_last_page (-2, '+', optarg + 1)))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  985|->             file_names[n_files++] = optarg;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  986|             break;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  987|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1210,
                    "column": 29,
                    "event": "warning[core.NullDereference]",
                    "message": "Array access (from variable 'file_names') results in a null pointer dereference",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 942,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/stdlib.h",
                    "line": 97,
                    "column": 20,
                    "event": "note",
                    "message": "expanded from macro 'MB_CUR_MAX'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 942,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 955,
                    "column": 17,
                    "event": "note",
                    "message": "Assuming 'argc' is <= 1",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 955,
                    "column": 17,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 955,
                    "column": 3,
                    "event": "note",
                    "message": "Null pointer value stored to 'file_names'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 959,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 963,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 963,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 964,
                    "column": 9,
                    "event": "note",
                    "message": " Execution continues on line 1138",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1138,
                    "column": 7,
                    "event": "note",
                    "message": "'column_count_string' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1138,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1144,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'date_format' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1144,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1152,
                    "column": 7,
                    "event": "note",
                    "message": "'first_page_number' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1152,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1155,
                    "column": 7,
                    "event": "note",
                    "message": "'parallel_files' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1155,
                    "column": 22,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1159,
                    "column": 7,
                    "event": "note",
                    "message": "'parallel_files' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1159,
                    "column": 22,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1167,
                    "column": 7,
                    "event": "note",
                    "message": "'old_options' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1167,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1208,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming 'optind' is < 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1208,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/pr.c",
                    "line": 1210,
                    "column": 29,
                    "event": "note",
                    "message": "Array access (from variable 'file_names') results in a null pointer dereference",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1208|     for (; optind < argc; optind++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1209|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1210|->       file_names[n_files++] = argv[optind];",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1211|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1212|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 688,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'digest_word_file'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 733,
                    "column": 3,
                    "event": "warning[-Wanalyzer-null-argument]",
                    "message": "use of NULL where non-null expected",
                    "verbosity_level": 0
                },
                {
                    "file_name": "<command-line>",
                    "line": 0,
                    "event": "note",
                    "message": "(1) entry to 'single_binary_main_ptx'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 1795,
                    "column": 1,
                    "event": "note",
                    "message": "in expansion of macro 'main'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 1993,
                    "column": 3,
                    "event": "note",
                    "message": "(2) calling 'initialize_regex' from 'single_binary_main_ptx'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 432,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to 'initialize_regex'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 451,
                    "column": 10,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 459,
                    "column": 20,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 459,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 460,
                    "column": 5,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 460,
                    "column": 5,
                    "event": "note",
                    "message": "(8) calling 'compile_regex' from 'initialize_regex'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 404,
                    "column": 1,
                    "event": "note",
                    "message": "(9) entry to 'compile_regex'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 413,
                    "column": 51,
                    "event": "note",
                    "message": "(10) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 416,
                    "column": 6,
                    "event": "note",
                    "message": "(12) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 423,
                    "column": 3,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 460,
                    "column": 5,
                    "event": "note",
                    "message": "(14) returning to 'initialize_regex' from 'compile_regex'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 474,
                    "column": 10,
                    "event": "note",
                    "message": "(15) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 487,
                    "column": 11,
                    "event": "note",
                    "message": "(16) inlined call to 'memset' from 'initialize_regex'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/bits/string_fortified.h",
                    "line": 59,
                    "column": 10,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'digest_word_file'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 1993,
                    "column": 3,
                    "event": "note",
                    "message": "(18) returning to 'single_binary_main_ptx' from 'initialize_regex'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 1997,
                    "column": 6,
                    "event": "note",
                    "message": "(19) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 2004,
                    "column": 7,
                    "event": "note",
                    "message": "(20) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 2004,
                    "column": 6,
                    "event": "note",
                    "message": "(21) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 2006,
                    "column": 7,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 2006,
                    "column": 7,
                    "event": "note",
                    "message": "(23) calling 'digest_word_file' from 'single_binary_main_ptx'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 689,
                    "column": 1,
                    "event": "note",
                    "message": "(24) entry to 'digest_word_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 695,
                    "column": 3,
                    "event": "note",
                    "message": "(25) calling 'swallow_file_in_memory' from 'digest_word_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 507,
                    "column": 1,
                    "event": "note",
                    "message": "(26) entry to 'swallow_file_in_memory'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 514,
                    "column": 48,
                    "event": "note",
                    "message": "(27) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 518,
                    "column": 20,
                    "event": "note",
                    "message": "(28) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 520,
                    "column": 6,
                    "event": "note",
                    "message": "(29) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 523,
                    "column": 6,
                    "event": "note",
                    "message": "(30) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 523,
                    "column": 6,
                    "event": "note",
                    "message": "(31) following 'false' branch (when 'using_stdin == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 526,
                    "column": 21,
                    "event": "note",
                    "message": "(32) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 695,
                    "column": 3,
                    "event": "note",
                    "message": "(33) returning to 'digest_word_file' from 'swallow_file_in_memory'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 697,
                    "column": 16,
                    "event": "note",
                    "message": "(34) '0' is NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 704,
                    "column": 17,
                    "event": "note",
                    "message": "(35) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 733,
                    "column": 29,
                    "event": "note",
                    "message": "(36) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 733,
                    "column": 15,
                    "event": "note",
                    "message": "(37) '0' is NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 733,
                    "column": 3,
                    "event": "note",
                    "message": "(38) argument 1 ('*table.start') NULL where non-null expected",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/single/lib/stdlib.h",
                    "line": 36,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 82,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "/usr/include/stdlib.h",
                    "line": 970,
                    "column": 13,
                    "event": "note",
                    "message": "argument 1 of 'qsort' must be non-null",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  731|     /* Finally, sort all the words read.  */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  732|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  733|->   qsort (table->start, table->length, sizeof table->start[0], compare_words);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  734|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  735|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 733,
                    "column": 3,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 697,
                    "column": 3,
                    "event": "note",
                    "message": "Null pointer value stored to field 'start'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 704,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 733",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/ptx.c",
                    "line": 733,
                    "column": 3,
                    "event": "note",
                    "message": "Null pointer passed to 1st parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  731|     /* Finally, sort all the words read.  */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  732|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  733|->   qsort (table->start, table->length, sizeof table->start[0], compare_words);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  734|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  735|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/selinux.c",
                    "line": 314,
                    "column": 22,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Although the value stored to 'ent' is used in the enclosing expression, the value is never actually read from 'ent'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/selinux.c",
                    "line": 314,
                    "column": 22,
                    "event": "note",
                    "message": "Although the value stored to 'ent' is used in the enclosing expression, the value is never actually read from 'ent'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  312|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  313|     int err = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  314|->   for (FTSENT *ent; (ent = fts_read (fts)); )",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  315|       if (restorecon_private (selabel_handle, fts->fts_path) < 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  316|         err = errno;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'seq_fast'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 485,
                    "column": 11,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xmalloc(inc_size + 1)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 567,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 629,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch (when 'n_args > 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 635,
                    "column": 6,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 635,
                    "column": 6,
                    "event": "note",
                    "message": "(4) following 'false' branch (when 'n_args <= 3')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 641,
                    "column": 6,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 641,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch (when 'format_str' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 659,
                    "column": 6,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 665,
                    "column": 6,
                    "event": "note",
                    "message": "(8) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 666,
                    "column": 7,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 669,
                    "column": 7,
                    "event": "note",
                    "message": "(10) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 669,
                    "column": 23,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 669,
                    "column": 23,
                    "event": "note",
                    "message": "(12) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 671,
                    "column": 42,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 673,
                    "column": 7,
                    "event": "note",
                    "message": "(14) calling 'seq_fast' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 458,
                    "column": 1,
                    "event": "note",
                    "message": "(15) entry to 'seq_fast'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 482,
                    "column": 6,
                    "event": "note",
                    "message": "(16) following 'true' branch (when the strings are non-equal)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 484,
                    "column": 12,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 484,
                    "column": 12,
                    "event": "note",
                    "message": "(18) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/seq.c",
                    "line": 485,
                    "column": 11,
                    "event": "note",
                    "message": "(19) 'xmalloc(inc_size + 1)' leaks here; was allocated at (18)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  483|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  484|         q0 = xmalloc (inc_size + 1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  485|->       q = memcpy (q0 + inc_size - q_len, b, q_len + 1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  486|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  487|     else",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/sort.c",
                    "line": 0,
                    "event": "internal warning",
                    "message": "child 26425 timed out after 30s",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/sort.c",
                    "line": 0,
                    "event": "internal warning",
                    "message": "child 26426 timed out after 30s",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/sort.c",
                    "line": 0,
                    "event": "internal warning",
                    "message": "child 40468 timed out after 30s",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/sort.c",
                    "line": 0,
                    "event": "internal warning",
                    "message": "child 40471 timed out after 30s",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 457,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/sort.c",
                    "line": 1160,
                    "event": "warning[uninitvar]",
                    "message": "Uninitialized variable: pid",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1158|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1159|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1160|->   if (pid < 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1161|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1162|         saved_errno = errno;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 457,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/sort.c",
                    "line": 4776,
                    "event": "warning[uninitvar]",
                    "message": "Uninitialized variable: buf.buf",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 4774|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 4775|    finish:",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 4776|->   free (buf.buf);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 4777|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 4778|     if (! output_file_created)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1503,
                    "column": 30,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 39,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1502,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1502,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1503,
                    "column": 30,
                    "event": "note",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1501|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1502|             if (reversed)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1503|->             mode->c_cflag = (mode->c_cflag & ~PARENB & ~CSIZE) | CS8;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1504|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1505|               mode->c_cflag = (mode->c_cflag & ~PARODD & ~CSIZE) | PARENB | CS7;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1505,
                    "column": 30,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 39,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1502,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1502,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1505,
                    "column": 30,
                    "event": "note",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1503|               mode->c_cflag = (mode->c_cflag & ~PARENB & ~CSIZE) | CS8;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1504|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1505|->             mode->c_cflag = (mode->c_cflag & ~PARODD & ~CSIZE) | PARENB | CS7;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1506|           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1507|         else if (STREQ (info->name, \"oddp\"))",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1510,
                    "column": 30,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1509,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1509,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1510,
                    "column": 30,
                    "event": "note",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1508|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1509|             if (reversed)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1510|->             mode->c_cflag = (mode->c_cflag & ~PARENB & ~CSIZE) | CS8;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1511|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1512|               mode->c_cflag = (mode->c_cflag & ~CSIZE) | CS7 | PARODD | PARENB;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1512,
                    "column": 30,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1509,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1509,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1512,
                    "column": 30,
                    "event": "note",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1510|               mode->c_cflag = (mode->c_cflag & ~PARENB & ~CSIZE) | CS8;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1511|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1512|->             mode->c_cflag = (mode->c_cflag & ~CSIZE) | CS7 | PARODD | PARENB;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1513|           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1514|         else if (STREQ (info->name, \"nl\"))",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1518,
                    "column": 32,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_iflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1516,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1516,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1518,
                    "column": 32,
                    "event": "note",
                    "message": "Access to field 'c_iflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1516|             if (reversed)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1517|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1518|->               mode->c_iflag = (mode->c_iflag | ICRNL) & ~INLCR & ~IGNCR;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1519|                 mode->c_oflag = (mode->c_oflag",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1520|   #ifdef ONLCR",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1534,
                    "column": 31,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_iflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1516,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1516,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1534,
                    "column": 31,
                    "event": "note",
                    "message": "Access to field 'c_iflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1532|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1533|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1534|->               mode->c_iflag = mode->c_iflag & ~ICRNL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1535|   #ifdef ONLCR",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1536|                 mode->c_oflag = mode->c_oflag & ~ONLCR;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1542,
                    "column": 30,
                    "event": "warning[core.NullDereference]",
                    "message": "Array access (via field 'c_cc') results in a null pointer dereference",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1542,
                    "column": 30,
                    "event": "note",
                    "message": "Array access (via field 'c_cc') results in a null pointer dereference",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1540|         else if (STREQ (info->name, \"ek\"))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1541|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1542|->           mode->c_cc[VERASE] = CERASE;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1543|             mode->c_cc[VKILL] = CKILL;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1544|           }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1550,
                    "column": 27,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_lflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1549,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1549,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1550,
                    "column": 27,
                    "event": "note",
                    "message": "Access to field 'c_lflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1548|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1549|             if (reversed)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1550|->             mode->c_lflag |= ICANON;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1551|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1552|               mode->c_lflag &= ~ICANON;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1552,
                    "column": 27,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_lflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1549,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1549,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1552,
                    "column": 27,
                    "event": "note",
                    "message": "Access to field 'c_lflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1550|               mode->c_lflag |= ICANON;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1551|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1552|->             mode->c_lflag &= ~ICANON;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1553|           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1554|         else if (STREQ (info->name, \"pass8\"))",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1558,
                    "column": 32,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1556,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1556,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1558,
                    "column": 32,
                    "event": "note",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1556|             if (reversed)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1557|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1558|->               mode->c_cflag = (mode->c_cflag & ~CSIZE) | CS7 | PARENB;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1559|                 mode->c_iflag |= ISTRIP;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1560|               }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1563,
                    "column": 32,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1556,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1556,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1563,
                    "column": 32,
                    "event": "note",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1561|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1562|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1563|->               mode->c_cflag = (mode->c_cflag & ~PARENB & ~CSIZE) | CS8;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1564|                 mode->c_iflag &= ~ISTRIP;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1565|               }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1571,
                    "column": 32,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1569,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1569,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1571,
                    "column": 32,
                    "event": "note",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1569|             if (reversed)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1570|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1571|->               mode->c_cflag = (mode->c_cflag & ~CSIZE) | CS7 | PARENB;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1572|                 mode->c_iflag |= ISTRIP;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1573|                 mode->c_oflag |= OPOST;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1577,
                    "column": 32,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1569,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1569,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1577,
                    "column": 32,
                    "event": "note",
                    "message": "Access to field 'c_cflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1575|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1576|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1577|->               mode->c_cflag = (mode->c_cflag & ~PARENB & ~CSIZE) | CS8;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1578|                 mode->c_iflag &= ~ISTRIP;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1579|                 mode->c_oflag &= ~OPOST;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1588,
                    "column": 29,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_iflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 42,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1584,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1584,
                    "column": 37,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1585,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1585,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1585,
                    "column": 44,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1584,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1588,
                    "column": 29,
                    "event": "note",
                    "message": "Access to field 'c_iflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1586|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1587|                 /* Cooked mode. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1588|->               mode->c_iflag |= BRKINT | IGNPAR | ISTRIP | ICRNL | IXON;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1589|                 mode->c_oflag |= OPOST;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1590|                 mode->c_lflag |= ISIG | ICANON;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1601,
                    "column": 29,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_iflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 42,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1584,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1584,
                    "column": 37,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1585,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1585,
                    "column": 40,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1601,
                    "column": 29,
                    "event": "note",
                    "message": "Access to field 'c_iflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1599|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1600|                 /* Raw mode. */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1601|->               mode->c_iflag = 0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1602|                 mode->c_oflag &= ~OPOST;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1603|                 mode->c_lflag &= ~(ISIG | ICANON",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1616,
                    "column": 27,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_iflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 45,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1613,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1615,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1615,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1616,
                    "column": 27,
                    "event": "note",
                    "message": "Access to field 'c_iflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1614|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1615|             if (reversed)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1616|->             mode->c_iflag |= IXANY;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1617|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1618|               mode->c_iflag &= ~IXANY;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1618,
                    "column": 27,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_iflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 45,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1613,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1615,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1615,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1618,
                    "column": 27,
                    "event": "note",
                    "message": "Access to field 'c_iflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1616|               mode->c_iflag |= IXANY;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1617|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1618|->             mode->c_iflag &= ~IXANY;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1619|           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1620|   #endif",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1625,
                    "column": 30,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_oflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 45,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1613,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1613,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1622,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1624,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1624,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1625,
                    "column": 30,
                    "event": "note",
                    "message": "Access to field 'c_oflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1623|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1624|             if (reversed)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1625|->             mode->c_oflag = (mode->c_oflag & ~TABDLY) | TAB3;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1626|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1627|               mode->c_oflag = (mode->c_oflag & ~TABDLY) | TAB0;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1627,
                    "column": 30,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_oflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 45,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1613,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1613,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1622,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1624,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1624,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1627,
                    "column": 30,
                    "event": "note",
                    "message": "Access to field 'c_oflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1625|               mode->c_oflag = (mode->c_oflag & ~TABDLY) | TAB3;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1626|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1627|->             mode->c_oflag = (mode->c_oflag & ~TABDLY) | TAB0;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1628|           }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1629|   #else",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1646,
                    "column": 29,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_lflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 45,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1613,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1613,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1622,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1622,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1642,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1644,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1644,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1646,
                    "column": 29,
                    "event": "note",
                    "message": "Access to field 'c_lflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1644|             if (reversed)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1645|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1646|->               mode->c_lflag &= ~XCASE;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1647|                 mode->c_iflag &= ~IUCLC;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1648|                 mode->c_oflag &= ~OLCUC;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1652,
                    "column": 29,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_lflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 45,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1613,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1613,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1622,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1622,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1642,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1644,
                    "column": 15,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1644,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1652,
                    "column": 29,
                    "event": "note",
                    "message": "Access to field 'c_lflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1650|             else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1651|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1652|->               mode->c_lflag |= XCASE;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1653|                 mode->c_iflag |= IUCLC;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1654|                 mode->c_oflag |= OLCUC;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1659,
                    "column": 23,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'c_lflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 45,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1613,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1613,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1622,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1622,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1641,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1641,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1642,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1641,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1658,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1659,
                    "column": 23,
                    "event": "note",
                    "message": "Access to field 'c_lflag' results in a dereference of a null pointer (loaded from variable 'mode')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1657|   #endif",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1658|         else if (STREQ (info->name, \"crt\"))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1659|->         mode->c_lflag |= ECHOE",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1660|   #ifdef ECHOCTL",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1661|             | ECHOCTL",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1669,
                    "column": 29,
                    "event": "warning[core.NullDereference]",
                    "message": "Array access (via field 'c_cc') results in a null pointer dereference",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1547,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1554,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1567,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 45,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1582,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1613,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1613,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1622,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1622,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1641,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1641,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1642,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1641,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1658,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1658,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1667,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1669,
                    "column": 29,
                    "event": "note",
                    "message": "Array access (via field 'c_cc') results in a null pointer dereference",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1667|         else if (STREQ (info->name, \"dec\"))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1668|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1669|->           mode->c_cc[VINTR] = 3;\t/* ^C */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1670|             mode->c_cc[VERASE] = 127;\t/* DEL */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1671|             mode->c_cc[VKILL] = 21;\t/* ^U */",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 2284,
                    "column": 42,
                    "event": "warning[core.NullDereference]",
                    "message": "Array access (via field 'c_cc') results in a null pointer dereference",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'k' is < 'n_settings'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1114,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'arg' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1122,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1125,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1130,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming field 'name' is not equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1135,
                    "column": 7,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 15,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1137,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1139,
                    "column": 15,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 68,
                    "event": "note",
                    "message": "Passing value via 3rd parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1141,
                    "column": 33,
                    "event": "note",
                    "message": "Calling 'set_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 7,
                    "event": "note",
                    "message": "'reversed' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1492,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'bitsp' is equal to nullptr",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1497,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 42,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1500,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1507,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1514,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'STREQ'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1540,
                    "column": 12,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1545,
                    "column": 12,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1546,
                    "column": 20,
                    "event": "note",
                    "message": "Passing null pointer value via 1st parameter 'mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 1546,
                    "column": 9,
                    "event": "note",
                    "message": "Calling 'sane_mode'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 2278,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/stty.c",
                    "line": 2284,
                    "column": 42,
                    "event": "note",
                    "message": "Array access (via field 'c_cc') results in a null pointer dereference",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2282|           break;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2283|   #endif",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2284|->       mode->c_cc[control_info[i].offset] = control_info[i].saneval;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2285|       }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2286|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 2,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 28,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'decode_output_arg'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xstrdup(arg)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 453,
                    "column": 15,
                    "event": "note",
                    "message": "in expansion of macro 'STREQ'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1605,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1638,
                    "column": 10,
                    "event": "note",
                    "message": "(2) following 'false' branch (when 'c != -1')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1641,
                    "column": 7,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1721,
                    "column": 14,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1726,
                    "column": 14,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1726,
                    "column": 14,
                    "event": "note",
                    "message": "(6) following 'false' branch (when 'posix_format == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1731,
                    "column": 15,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1731,
                    "column": 14,
                    "event": "note",
                    "message": "(8) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1736,
                    "column": 23,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 1738,
                    "column": 13,
                    "event": "note",
                    "message": "(10) calling 'decode_output_arg' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 436,
                    "column": 1,
                    "event": "note",
                    "message": "(11) entry to 'decode_output_arg'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 438,
                    "column": 24,
                    "event": "note",
                    "message": "(12) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 443,
                    "column": 21,
                    "event": "note",
                    "message": "(13) when 'strchr' returns non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 446,
                    "column": 10,
                    "event": "note",
                    "message": "(14) following 'true' branch (when 'comma' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 447,
                    "column": 15,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 451,
                    "column": 27,
                    "event": "note",
                    "message": "(16) following 'true' branch (when 'i != 12')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 453,
                    "column": 15,
                    "event": "note",
                    "message": "in expansion of macro 'STREQ'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 453,
                    "column": 14,
                    "event": "note",
                    "message": "(18) following 'false' branch (when the strings are non-equal)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 451,
                    "column": 62,
                    "event": "note",
                    "message": "(19) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 459,
                    "column": 10,
                    "event": "note",
                    "message": "(20) following 'false' branch (when 'field != 12')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 465,
                    "column": 28,
                    "event": "note",
                    "message": "(21) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 465,
                    "column": 10,
                    "event": "note",
                    "message": "(22) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 473,
                    "column": 7,
                    "event": "note",
                    "message": "(23) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 473,
                    "column": 7,
                    "event": "note",
                    "message": "(24) following 'case 4:' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 492,
                    "column": 9,
                    "event": "note",
                    "message": "(25) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 493,
                    "column": 11,
                    "event": "note",
                    "message": "(26) calling 'alloc_field' from 'decode_output_arg'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 418,
                    "column": 1,
                    "event": "note",
                    "message": "(27) entry to 'alloc_field'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 423,
                    "column": 6,
                    "event": "note",
                    "message": "(28) following 'true' branch (when 'c' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 424,
                    "column": 36,
                    "event": "note",
                    "message": "(29) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/assure.h",
                    "line": 23,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 29,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/assure.h",
                    "line": 40,
                    "column": 20,
                    "event": "note",
                    "message": "(30) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 426,
                    "column": 3,
                    "event": "note",
                    "message": "in expansion of macro 'affirm'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 429,
                    "column": 22,
                    "event": "note",
                    "message": "(31) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 493,
                    "column": 11,
                    "event": "note",
                    "message": "(32) returning to 'decode_output_arg' from 'alloc_field'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 501,
                    "column": 10,
                    "event": "note",
                    "message": "(33) following 'true' branch (when 'comma' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(34) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 443,
                    "column": 21,
                    "event": "note",
                    "message": "(35) when 'strchr' returns NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 446,
                    "column": 10,
                    "event": "note",
                    "message": "(36) following 'false' branch (when 'comma' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 451,
                    "column": 7,
                    "event": "note",
                    "message": "(37) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 451,
                    "column": 27,
                    "event": "note",
                    "message": "(38) following 'true' branch (when 'i != 12')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "(39) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 453,
                    "column": 15,
                    "event": "note",
                    "message": "in expansion of macro 'STREQ'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 453,
                    "column": 14,
                    "event": "note",
                    "message": "(40) following 'true' branch (when the strings are equal)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 455,
                    "column": 21,
                    "event": "note",
                    "message": "(41) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 459,
                    "column": 10,
                    "event": "note",
                    "message": "(42) following 'false' branch (when 'field != 12')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 465,
                    "column": 28,
                    "event": "note",
                    "message": "(43) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 186,
                    "column": 22,
                    "event": "note",
                    "message": "(44) 'xstrdup(arg)' leaks here; was allocated at (12)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/df.c",
                    "line": 453,
                    "column": 15,
                    "event": "note",
                    "message": "in expansion of macro 'STREQ'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  184|   }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  185|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  186|-> #define STREQ(a, b) (strcmp (a, b) == 0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  187|   #define STREQ_LEN(a, b, n) (strncmp (a, b, n) == 0) /* n==-1 means unbounded */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  188|   #define STRPREFIX(a, b) (strncmp (a, b, strlen (b)) == 0)",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 840,
                    "column": 35,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'nbytes' results in a dereference of a null pointer (loaded from variable 'tmp')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2380,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'from_start' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2380,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2386,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'optind' is >= 'argc'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2386,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2401,
                    "column": 5,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2402,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2401,
                    "column": 5,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 2406",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2406,
                    "column": 9,
                    "event": "note",
                    "message": "'found_hyphen' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2406,
                    "column": 9,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2406,
                    "column": 25,
                    "event": "note",
                    "message": "'follow_mode' is not equal to Follow_name",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2406,
                    "column": 5,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2413,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming 'forever' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2413,
                    "column": 17,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2428,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'n_units' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2428,
                    "column": 17,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2432,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2432,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 2435",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2435,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'header_mode' is not equal to always",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2435,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2436,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'header_mode' is not equal to multiple_files",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2436,
                    "column": 41,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2441,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2442,
                    "column": 11,
                    "event": "note",
                    "message": "Calling 'tail_file'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1994,
                    "column": 7,
                    "event": "note",
                    "message": "'is_stdin' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1994,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2003,
                    "column": 19,
                    "event": "note",
                    "message": "Assuming 'reopen_inaccessible_files' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2003,
                    "column": 45,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2005,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2023,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'print_headers' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2023,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2025,
                    "column": 12,
                    "event": "note",
                    "message": "Calling 'tail'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1977,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'count_lines' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1977,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1980,
                    "column": 12,
                    "event": "note",
                    "message": "Calling 'tail_bytes'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1853,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1853,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1859,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'from_start' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1859,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1879,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'presume_input_pipe' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1879,
                    "column": 32,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1886,
                    "column": 30,
                    "event": "note",
                    "message": "Assuming 0 is >= field 'st_blksize'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/stat-size.h",
                    "line": 68,
                    "column": 28,
                    "event": "note",
                    "message": "expanded from macro 'STP_BLKSIZE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1886,
                    "column": 30,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/stat-size.h",
                    "line": 69,
                    "column": 28,
                    "event": "note",
                    "message": "expanded from macro 'STP_BLKSIZE'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1886,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 1887,
                    "column": 16,
                    "event": "note",
                    "message": "Calling 'pipe_bytes'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 790,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 793,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'n_read' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 793,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 793,
                    "column": 26,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 793,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 803,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 803,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 816,
                    "column": 15,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 816,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 790,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 793,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'n_read' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 793,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 793,
                    "column": 26,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 793,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 797,
                    "column": 7,
                    "event": "note",
                    "message": "Null pointer value stored to field 'next'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 803,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 803,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 816,
                    "column": 15,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 816,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 790,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 793,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'n_read' is not equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 793,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 793,
                    "column": 26,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 793,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 803,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 803,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 790,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 793,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'n_read' is equal to 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 793,
                    "column": 23,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 794,
                    "column": 9,
                    "event": "note",
                    "message": " Execution continues on line 829",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 831,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 840,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 840,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 840,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 840,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 840,
                    "column": 21,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 840,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 840,
                    "column": 58,
                    "event": "note",
                    "message": "Null pointer value stored to 'tmp'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 840,
                    "column": 35,
                    "event": "note",
                    "message": "Access to field 'nbytes' results in a dereference of a null pointer (loaded from variable 'tmp')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  838|     /* Run through the list, printing characters.  First, skip over unneeded",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  839|        buffers.  */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  840|->   for (tmp = first; total_bytes - tmp->nbytes > n_bytes; tmp = tmp->next)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  841|       total_bytes -= tmp->nbytes;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  842|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 758,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/tail.c",
                    "line": 2402,
                    "event": "warning[objectIndex]",
                    "message": "The address of local variable 'dummy_stdin' might be accessed at non-zero index.",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2400|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2401|       for (i = 0; i < n_files; i++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2402|->       if (STREQ (file[i], \"-\"))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2403|           found_hyphen = true;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 2404|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'tee_files'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 256,
                    "column": 3,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xnmalloc((long unsigned int)(nfiles + 1), 8)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 248,
                    "column": 17,
                    "event": "note",
                    "message": "(1) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 249,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch (when 'pipe_check == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 251,
                    "column": 8,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 253,
                    "column": 6,
                    "event": "note",
                    "message": "(4) following 'false' branch (when 'pipe_check == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/gettext.h",
                    "line": 26,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 164,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 24,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 172,
                    "column": 18,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 255,
                    "column": 24,
                    "event": "note",
                    "message": "in expansion of macro '_'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 259,
                    "column": 17,
                    "event": "note",
                    "message": "(6) following 'true' branch (when 'i <= nfiles')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 262,
                    "column": 37,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 263,
                    "column": 10,
                    "event": "note",
                    "message": "(8) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 265,
                    "column": 14,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 265,
                    "column": 14,
                    "event": "note",
                    "message": "(10) following 'false' branch (when 'pipe_check == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 740,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 268,
                    "column": 18,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/error.h",
                    "line": 408,
                    "column": 28,
                    "event": "note",
                    "message": "in definition of macro '__gl_error_call'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 267,
                    "column": 11,
                    "event": "note",
                    "message": "in expansion of macro 'error'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/error.h",
                    "line": 410,
                    "column": 6,
                    "event": "note",
                    "message": "(12) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/error.h",
                    "line": 471,
                    "column": 7,
                    "event": "note",
                    "message": "in expansion of macro '__gl_error_call'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 267,
                    "column": 11,
                    "event": "note",
                    "message": "in expansion of macro 'error'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/error.h",
                    "line": 398,
                    "column": 6,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/error.h",
                    "line": 413,
                    "column": 10,
                    "event": "note",
                    "message": "in expansion of macro '__gl_error_call1'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/error.h",
                    "line": 471,
                    "column": 7,
                    "event": "note",
                    "message": "in expansion of macro '__gl_error_call'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 267,
                    "column": 11,
                    "event": "note",
                    "message": "in expansion of macro 'error'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 256,
                    "column": 3,
                    "event": "note",
                    "message": "(14) 'xnmalloc((long unsigned int)(nfiles + 1), 8)' leaks here; was allocated at (1)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  254|       out_pollable[0] = iopoll_output_ok (fileno (descriptors[0]));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  255|     files[0] = bad_cast (_(\"standard output\"));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  256|->   setvbuf (stdout, nullptr, _IONBF, 0);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  257|     n_outputs++;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  258|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 262,
                    "column": 37,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xnmalloc((long unsigned int)(nfiles + 1), 8)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 119,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 177,
                    "column": 13,
                    "event": "note",
                    "message": "(2) calling 'tee_files' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 226,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to 'tee_files'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 248,
                    "column": 17,
                    "event": "note",
                    "message": "(4) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 249,
                    "column": 6,
                    "event": "note",
                    "message": "(5) following 'false' branch (when 'pipe_check == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 251,
                    "column": 8,
                    "event": "note",
                    "message": "(6) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 253,
                    "column": 6,
                    "event": "note",
                    "message": "(7) following 'false' branch (when 'pipe_check == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 172,
                    "column": 18,
                    "event": "note",
                    "message": "(8) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 255,
                    "column": 24,
                    "event": "note",
                    "message": "in expansion of macro '_'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 259,
                    "column": 17,
                    "event": "note",
                    "message": "(9) following 'true' branch (when 'i <= nfiles')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 262,
                    "column": 37,
                    "event": "note",
                    "message": "(10) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 263,
                    "column": 10,
                    "event": "note",
                    "message": "(11) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 265,
                    "column": 14,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 265,
                    "column": 14,
                    "event": "note",
                    "message": "(13) following 'false' branch (when 'pipe_check == 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 268,
                    "column": 18,
                    "event": "note",
                    "message": "(14) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/error.h",
                    "line": 408,
                    "column": 28,
                    "event": "note",
                    "message": "in definition of macro '__gl_error_call'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 267,
                    "column": 11,
                    "event": "note",
                    "message": "in expansion of macro 'error'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/error.h",
                    "line": 410,
                    "column": 6,
                    "event": "note",
                    "message": "(15) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/error.h",
                    "line": 471,
                    "column": 7,
                    "event": "note",
                    "message": "in expansion of macro '__gl_error_call'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 267,
                    "column": 11,
                    "event": "note",
                    "message": "in expansion of macro 'error'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/error.h",
                    "line": 398,
                    "column": 6,
                    "event": "note",
                    "message": "(16) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/error.h",
                    "line": 413,
                    "column": 10,
                    "event": "note",
                    "message": "in expansion of macro '__gl_error_call1'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/separate/lib/error.h",
                    "line": 471,
                    "column": 7,
                    "event": "note",
                    "message": "in expansion of macro '__gl_error_call'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 267,
                    "column": 11,
                    "event": "note",
                    "message": "in expansion of macro 'error'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tee.c",
                    "line": 262,
                    "column": 37,
                    "event": "note",
                    "message": "(17) 'xnmalloc((long unsigned int)(nfiles + 1), 8)' leaks here; was allocated at (4)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  260|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  261|         /* Do not treat \"-\" specially - as mandated by POSIX.  */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  262|->        descriptors[i] = fopen (files[i], mode_string);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  263|         if (descriptors[i] == nullptr)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  264|           {",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/temp-stream.c",
                    "line": 96,
                    "event": "error[memleakOnRealloc]",
                    "message": "Common realloc mistake: 'tempbuf' nulled but not freed upon failure",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   94|         while (true)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   95|           {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   96|->           if (! (tempbuf = realloc (tempbuf, tempbuf_len)))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   97|               {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   98|                 error (0, errno, _(\"failed to make temporary file name\"));",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1817,
                    "column": 21,
                    "event": "warning[core.NullDereference]",
                    "message": "Access to field 'state' results in a dereference of a null pointer (loaded from variable 's2')",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1696,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1696,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 1733",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1734,
                    "column": 18,
                    "event": "note",
                    "message": "Assuming 'non_option_args' is not equal to 2",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1734,
                    "column": 39,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1735,
                    "column": 23,
                    "event": "note",
                    "message": "Assuming 'delete' is not equal to 'squeeze_repeats'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1736,
                    "column": 23,
                    "event": "note",
                    "message": "Assuming 'delete' is > 'squeeze_repeats'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1738,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'non_option_args' is >= 'min_operands'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1738,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1754,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'max_operands' is >= 'non_option_args'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1754,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1765,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1768,
                    "column": 7,
                    "event": "note",
                    "message": "'non_option_args' is not equal to 2",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1768,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1775,
                    "column": 5,
                    "event": "note",
                    "message": "Null pointer value stored to 's2'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1786,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'squeeze_repeats' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1786,
                    "column": 23,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1791,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming 'delete' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1791,
                    "column": 19,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1804,
                    "column": 12,
                    "event": "note",
                    "message": "'squeeze_repeats' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1804,
                    "column": 28,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1810,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming 'translating' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1810,
                    "column": 8,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1812,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'complement' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1812,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tr.c",
                    "line": 1817,
                    "column": 21,
                    "event": "note",
                    "message": "Access to field 'state' results in a dereference of a null pointer (loaded from variable 's2')",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1815|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1816|             set_initialize (s1, false, in_s1);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1817|->           s2->state = BEGIN_STATE;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1818|             for (int i = 0; i < N_CHARS; i++)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1819|               xlate[i] = i;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 422,
                    "column": 6,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xzalloc(56)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'tsort'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 531,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 545,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 551,
                    "column": 3,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 551,
                    "column": 3,
                    "event": "note",
                    "message": "(4) calling 'tsort' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 429,
                    "column": 1,
                    "event": "note",
                    "message": "(5) entry to 'tsort'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 438,
                    "column": 23,
                    "event": "note",
                    "message": "(6) inlined call to 'new_item' from 'tsort'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 104,
                    "column": 20,
                    "event": "note",
                    "message": "(7) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'tsort'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 453,
                    "column": 14,
                    "event": "note",
                    "message": "(8) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 471,
                    "column": 6,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 471,
                    "column": 6,
                    "event": "note",
                    "message": "(10) following 'false' branch (when 'j' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 476,
                    "column": 3,
                    "event": "note",
                    "message": "(11) inlined call to 'walk_tree' from 'tsort'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 422,
                    "column": 11,
                    "event": "note",
                    "message": "(12) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 422,
                    "column": 6,
                    "event": "note",
                    "message": "(13) 'xzalloc(56)' leaks here; was allocated at (7)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  420|   walk_tree (struct item *root, bool (*action) (struct item *))",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  421|   {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  422|->   if (root->right)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  423|       recurse_tree (root->right, action);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  424|   }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 443,
                    "column": 3,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'xzalloc(56)'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 531,
                    "column": 1,
                    "event": "note",
                    "message": "(1) entry to 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 545,
                    "column": 6,
                    "event": "note",
                    "message": "(2) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 551,
                    "column": 3,
                    "event": "note",
                    "message": "(3) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 551,
                    "column": 3,
                    "event": "note",
                    "message": "(4) calling 'tsort' from 'main'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 429,
                    "column": 1,
                    "event": "note",
                    "message": "(5) entry to 'tsort'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 438,
                    "column": 23,
                    "event": "note",
                    "message": "(6) inlined call to 'new_item' from 'tsort'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 104,
                    "column": 20,
                    "event": "note",
                    "message": "(7) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'tsort'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 451,
                    "column": 10,
                    "event": "note",
                    "message": "(8) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/assure.h",
                    "line": 23,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 28,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/assure.h",
                    "line": 40,
                    "column": 20,
                    "event": "note",
                    "message": "(9) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 458,
                    "column": 7,
                    "event": "note",
                    "message": "in expansion of macro 'affirm'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/tsort.c",
                    "line": 443,
                    "column": 3,
                    "event": "note",
                    "message": "(10) 'xzalloc(56)' leaks here; was allocated at (7)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  441|       error (EXIT_FAILURE, errno, \"%s\", quotef (file));",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  442|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  443|->   fadvise (stdin, FADVISE_SEQUENTIAL);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  444|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  445|     init_tokenbuffer (&tokenbuffer);",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 276,
                    "column": 19,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'next_tab_column' is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/unexpand.c",
                    "line": 276,
                    "column": 19,
                    "event": "note",
                    "message": "Value stored to 'next_tab_column' is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  274|                        next tab stop.  */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  275|                     column -= !!column;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  276|->                   next_tab_column = column;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  277|                     tab_index -= !!tab_index;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  278|                   }",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "COMPILER_WARNING",
            "language": "c/c++",
            "tool": "gcc",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/wc_avx2.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'wc_lines_avx2'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/wc_avx2.c",
                    "line": 38,
                    "column": 5,
                    "event": "warning[-Wpsabi]",
                    "message": "AVX vector return without AVX enabled changes the ABI",
                    "verbosity_level": 0
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   36|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   37|     __m256i",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   38|->     zeroes = _mm256_setzero_si256 (),",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   39|       endlines = _mm256_set1_epi8 ('\\n');",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "   40|   ",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 399,
                    "column": 16,
                    "event": "warning[core.NullDereference]",
                    "message": "Dereference of null pointer",
                    "verbosity_level": 0
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 698,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 698,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is false. Execution continues on line 791",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 791,
                    "column": 7,
                    "event": "note",
                    "message": "'assumptions' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 791,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 797,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'include_exit' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 797,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 802,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 802,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 813,
                    "column": 3,
                    "event": "note",
                    "message": "Control jumps to 'case -1:'  at line 818",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 820,
                    "column": 7,
                    "event": "note",
                    "message": "Calling 'who'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 621,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'short_list' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 621,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 623,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 623,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 626,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'short_list' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 626,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 629,
                    "column": 5,
                    "event": "note",
                    "message": "Calling 'scan_entries'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 569,
                    "column": 21,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/intprops.h",
                    "line": 46,
                    "column": 32,
                    "event": "note",
                    "message": "expanded from macro 'TYPE_MINIMUM'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/intprops.h",
                    "line": 48,
                    "column": 9,
                    "event": "note",
                    "message": "expanded from macro 'TYPE_MAXIMUM'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 571,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'include_heading' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 571,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 574,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming 'my_line_only' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 574,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 583,
                    "column": 3,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 585,
                    "column": 12,
                    "event": "note",
                    "message": "'my_line_only' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 586,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 588,
                    "column": 15,
                    "event": "note",
                    "message": "Assuming 'need_users' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 588,
                    "column": 15,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 588,
                    "column": 29,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.h",
                    "line": 289,
                    "column": 4,
                    "event": "note",
                    "message": "expanded from macro 'IS_USER_PROCESS'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 588,
                    "column": 29,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.h",
                    "line": 289,
                    "column": 4,
                    "event": "note",
                    "message": "expanded from macro 'IS_USER_PROCESS'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 588,
                    "column": 29,
                    "event": "note",
                    "message": "Assuming field 'ut_type' is equal to 7",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.h",
                    "line": 289,
                    "column": 24,
                    "event": "note",
                    "message": "expanded from macro 'IS_USER_PROCESS'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/readutmp.h",
                    "line": 282,
                    "column": 36,
                    "event": "note",
                    "message": "expanded from macro 'UT_TYPE_USER_PROCESS'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 588,
                    "column": 11,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 589,
                    "column": 13,
                    "event": "note",
                    "message": "Calling 'print_user'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 336,
                    "column": 10,
                    "event": "note",
                    "message": "Assuming 'space' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 336,
                    "column": 10,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 339,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/filename.h",
                    "line": 97,
                    "column": 42,
                    "event": "note",
                    "message": "expanded from macro 'IS_ABSOLUTE_FILE_NAME'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/filename.h",
                    "line": 93,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'ISSLASH'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 339,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 344,
                    "column": 12,
                    "event": "note",
                    "message": "'dev_dirfd' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 344,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 347,
                    "column": 15,
                    "event": "note",
                    "message": "Assuming 'dev_dirfd' is >= 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 347,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 353,
                    "column": 7,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/fcntl.h",
                    "line": 149,
                    "column": 20,
                    "event": "note",
                    "message": "expanded from macro 'AT_FDCWD'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 353,
                    "column": 28,
                    "event": "note",
                    "message": "Assuming the condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 353,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 364,
                    "column": 7,
                    "event": "note",
                    "message": "'last_change' is 0",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 364,
                    "column": 3,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 370,
                    "column": 7,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 370,
                    "column": 3,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 378,
                    "column": 11,
                    "event": "note",
                    "message": "Assuming 'display' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 378,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 381,
                    "column": 11,
                    "event": "note",
                    "message": "Left side of '&&' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 381,
                    "column": 23,
                    "event": "note",
                    "message": "Assuming 'do_lookup' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 381,
                    "column": 7,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 387,
                    "column": 13,
                    "event": "note",
                    "message": "'host' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 387,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 390,
                    "column": 11,
                    "event": "note",
                    "message": "'display' is non-null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 390,
                    "column": 7,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 393,
                    "column": 15,
                    "event": "note",
                    "message": "Assuming 'hostlen' is >= 'needed'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 393,
                    "column": 11,
                    "event": "note",
                    "message": "Taking false branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 399,
                    "column": 12,
                    "event": "note",
                    "message": "Null pointer value stored to 'p'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 399,
                    "column": 16,
                    "event": "note",
                    "message": "Dereference of null pointer",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  397|               }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  398|             char *p = hoststr;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  399|->           *p++ = '(';",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  400|             p = stpcpy (p, host);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  401|             *p++ = ':';",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "GCC_ANALYZER_WARNING",
            "cwe": 401,
            "language": "c/c++",
            "tool": "gcc-analyzer",
            "key_event_idx": 1,
            "events": [
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'print_user'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 432,
                    "column": 1,
                    "event": "warning[-Wanalyzer-malloc-leak]",
                    "message": "leak of 'host'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "<command-line>",
                    "line": 0,
                    "event": "note",
                    "message": "(1) entry to 'single_binary_main_who'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 685,
                    "column": 1,
                    "event": "note",
                    "message": "in expansion of macro 'main'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 820,
                    "column": 7,
                    "event": "note",
                    "message": "(2) calling 'who' from 'single_binary_main_who'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 617,
                    "column": 1,
                    "event": "note",
                    "message": "(3) entry to 'who'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 623,
                    "column": 6,
                    "event": "note",
                    "message": "(4) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 626,
                    "column": 7,
                    "event": "note",
                    "message": "(5) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 626,
                    "column": 6,
                    "event": "note",
                    "message": "(6) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 629,
                    "column": 5,
                    "event": "note",
                    "message": "(7) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 629,
                    "column": 5,
                    "event": "note",
                    "message": "(8) calling 'scan_entries' from 'who'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 566,
                    "column": 1,
                    "event": "note",
                    "message": "(9) entry to 'scan_entries'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 574,
                    "column": 6,
                    "event": "note",
                    "message": "(10) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "cc1",
                    "line": 0,
                    "event": "note",
                    "message": "(11) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 583,
                    "column": 10,
                    "event": "note",
                    "message": "(12) following 'true' branch (when 'n != 0')...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 585,
                    "column": 11,
                    "event": "note",
                    "message": "(13) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 585,
                    "column": 10,
                    "event": "note",
                    "message": "(14) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 588,
                    "column": 15,
                    "event": "note",
                    "message": "(15) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 588,
                    "column": 14,
                    "event": "note",
                    "message": "(16) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 589,
                    "column": 13,
                    "event": "note",
                    "message": "(17) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 589,
                    "column": 13,
                    "event": "note",
                    "message": "(18) calling 'print_user' from 'scan_entries'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 321,
                    "column": 1,
                    "event": "note",
                    "message": "(19) entry to 'print_user'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 335,
                    "column": 17,
                    "event": "note",
                    "message": "(20) when 'strchr' returns NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 336,
                    "column": 28,
                    "event": "note",
                    "message": "(21) following 'false' branch (when 'space' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/dirname.h",
                    "line": 29,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/system.h",
                    "line": 257,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 31,
                    "event": "included_from",
                    "message": "Included from here.",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/lib/filename.h",
                    "line": 97,
                    "column": 61,
                    "event": "note",
                    "message": "(22) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/lib/filename.h",
                    "line": 93,
                    "column": 23,
                    "event": "note",
                    "message": "in definition of macro 'ISSLASH'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 339,
                    "column": 7,
                    "event": "note",
                    "message": "in expansion of macro 'IS_ABSOLUTE_FILE_NAME'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 370,
                    "column": 6,
                    "event": "note",
                    "message": "(23) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 377,
                    "column": 17,
                    "event": "note",
                    "message": "(24) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 377,
                    "column": 17,
                    "event": "note",
                    "message": "(25) when 'strchr' returns NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 378,
                    "column": 10,
                    "event": "note",
                    "message": "(26) following 'false' branch (when 'display' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 381,
                    "column": 11,
                    "event": "note",
                    "message": "(27) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 381,
                    "column": 10,
                    "event": "note",
                    "message": "(28) following 'true' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 384,
                    "column": 18,
                    "event": "note",
                    "message": "(29) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 384,
                    "column": 18,
                    "event": "note",
                    "message": "(30) allocated here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 387,
                    "column": 10,
                    "event": "note",
                    "message": "(31) assuming 'canon_host(*utmp_ent.ut_host)' is non-NULL",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 387,
                    "column": 10,
                    "event": "note",
                    "message": "(32) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 390,
                    "column": 10,
                    "event": "note",
                    "message": "(33) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 390,
                    "column": 10,
                    "event": "note",
                    "message": "(34) following 'false' branch (when 'display' is NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 406,
                    "column": 26,
                    "event": "note",
                    "message": "(35) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 417,
                    "column": 10,
                    "event": "note",
                    "message": "(36) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 431,
                    "column": 23,
                    "event": "note",
                    "message": "(37) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 428,
                    "column": 3,
                    "event": "note",
                    "message": "(38) calling 'print_line' from 'print_user'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 232,
                    "column": 1,
                    "event": "note",
                    "message": "(39) entry to 'print_line'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 262,
                    "column": 9,
                    "event": "note",
                    "message": "(40) following 'true' branch (when 'user' is non-NULL)...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 262,
                    "column": 9,
                    "event": "note",
                    "message": "(41) inlined call to 'asprintf' from 'print_line'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/include/bits/stdio2.h",
                    "line": 206,
                    "column": 10,
                    "event": "note",
                    "message": "(42) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 0,
                    "event": "scope_hint",
                    "message": "In function 'print_user'",
                    "verbosity_level": 1
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 286,
                    "column": 6,
                    "event": "note",
                    "message": "(43) following 'false' branch...",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 291,
                    "column": 19,
                    "event": "note",
                    "message": "(44) ...to here",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 428,
                    "column": 3,
                    "event": "note",
                    "message": "(45) returning to 'print_user' from 'print_line'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "coreutils-9.5/src/who.c",
                    "line": 432,
                    "column": 1,
                    "event": "note",
                    "message": "(46) 'host' leaks here; was allocated at (30)",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  430|                 time_string (utmp_ent), idlestr, pidstr,",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  431|                 hoststr ? hoststr : \"\", \"\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  432|-> }",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  433|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  434|   static void",
                    "verbosity_level": 1
                }
            ]
        }
    ]
}
